/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: CommandQueue.cs,v 1.4 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;
using System.Threading;
using System.Collections;

using Zigumo.Network;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// R}hL[NX
	/// </summary>
	public class CommandQueue
	{
		/// <summary>
		/// L[ɂ߂R}h̐
		/// </summary>
		private int maxRequest = 128;
		private int maxThread = 4;
		private Queue commandQueue = new Queue();
		private ArrayList threadPool = new ArrayList();
		private AutoResetEvent waitEvent = new AutoResetEvent(false);

		/// <summary>
		/// CommandQueueRXgN^
		/// </summary>
		/// <param name="maxThread"></param>
		public CommandQueue()
		{
			//Xbh̐
			for(int i = 0; i < maxThread; i++) {
				WorkerThread worker = new WorkerThread(this);
				Thread workerThread = new Thread(new ThreadStart(worker.Run));
				workerThread.Name = "WorkerThread " + i.ToString();
				workerThread.Start();
				threadPool.Add(workerThread);
			}
		}

		/// <summary>
		/// [J[XbhI\bh
		/// </summary>
		public void ShutdownWorkers() {
			foreach(Thread th in threadPool) {
				th.Abort();
			}
		}

		/// <summary>
		/// R}ho^\bh
		/// </summary>
		/// <param name="command"></param>
		public void PutCommand(ICommand command) {
			//L[eʃ`FbN
			int count = 0;
			while(commandQueue.Count >= maxRequest) {
				Thread.Sleep(3000);//NGXg̏𒴂AXbhx~B
				if(count++ > 100)
					return;//΂炭҂ĂL[󂩂Ȃ̓R}hj
			}

			//L[ɃR}hǉ
			lock(commandQueue.SyncRoot) {
				commandQueue.Enqueue(command);
			}
			waitEvent.Set();//R}hǉꂽAx~̃XbhNB
		}

		/// <summary>
		/// R}h擾\bh
		/// R}h擾\bhł́AL[̒ɗ܂ĂR}h擾WorkerThreadŎsB
		/// </summary>
		/// <returns></returns>
		public ICommand GetCommand() {
			//L[`FbN
			while(commandQueue.Count <= 0) {
				waitEvent.WaitOne();//L[ɃR}hꍇ̓Xbhx~B
			}

			//R}h擾
			lock(commandQueue.SyncRoot) {
				return (ICommand)commandQueue.Dequeue();
			}
		}
	}
}
