/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ConnectionManager.cs,v 1.14 2003/04/25 03:08:15 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

using Zigumo.CommandObject;
using Zigumo.MessageObject;
using Zigumo.Model;
using Zigumo.Network;

namespace Zigumo
{
	/// <summary>
	/// P2PʐMSĂǗNX
	/// P2P̒ʐM͂̃RlNV}l[WőSĉB
	/// </summary>
	public class ConnectionManager
	{
		/// <summary>
		/// RlNV}l[Wg̎QƁBVOgp^[
		/// </summary>
		private static readonly ConnectionManager connectionManager = new ConnectionManager();
		/// <summary>
		/// ZigumoFromւ̎Q
		/// </summary>
		private ZigumoForm zigumoForm;
		/// <summary>
		/// model̎Q
		/// </summary>
		private ZigumoModel model;
		/// <summary>
		/// CommandControllerւ̎Q
		/// </summary>
		private CommandController commandController;
		/// <summary>
		/// RlNVi[pArrayList
		/// </summary>
		private ArrayList connectionPool = new ArrayList();
		/// <summary>
		/// ListenerThreadւ̎Q
		/// </summary>
		private P2PListenerThread p2pListenerThread;
		/// <summary>
		/// listenerThreadւ̎Q
		/// </summary>
		private Thread listener;
		/// <summary>
		/// T[ogXg
		/// </summary>
		private LRUCache serventList = new LRUCache(256);
		/// <summary>
		/// bZ[WIDLbVIuWFNgւ̎Q
		/// </summary>
		private LRUCache messageCache = new LRUCache(1000);

		private ConnectionManager()
		{
			//modelւ̎QƂZbg
			model = ZigumoModel.Model;

			//CommandControllerւ̎QƂZbg
			commandController = CommandController.Controller;

			//P2PpXi[̍쐬
			p2pListenerThread = new P2PListenerThread(model.PortNumber);
			listener = new Thread(new ThreadStart(p2pListenerThread.Listen));
			listener.Name = "P2P Listener thread";
			try {
				p2pListenerThread.StartUp();
			} catch(Exception e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
				model.Log.Write("Listener Startup faild");
				return;
			}
			listener.Start();
		}

		/// <summary>
		/// RlNV}l[Wg̃vpeB
		/// </summary>
		public static ConnectionManager Manager {
			get {
				return connectionManager;
			}
		}

		/// <summary>
		/// ZigumoForm̃vpeB
		/// </summary>
		public ZigumoForm Form {
			get {
				return zigumoForm;
			}
			set {
				zigumoForm = value;
			}
		}

		/// <summary>
		/// v[ւ̃RlNVǉ\bh
		/// </summary>
		/// <param name="con">TcpConnectionNXւ̎QƁBۂ̐ڑ񂪓</param>
		public P2PConnection AddConnection(P2PConnection p2pCon) {
			IPEndPoint remoteEndPoint = (IPEndPoint)p2pCon.Connection.Socket.RemoteEndPoint;

			model.Log.Write(string.Format("Startup P2PConnection ID={0} to {1}:{2}", p2pCon.ID, remoteEndPoint.Address.ToString(), remoteEndPoint.Port));

			lock(connectionPool.SyncRoot) {//Ƀv[ύXȂ悤bN
				if(!Contains(p2pCon)) {//RlNV݂Ȃꍇ̂ݒǉ
					connectionPool.Add(p2pCon);
				} else {
					//sOo
					model.Log.Write(string.Format("P2PConnection ID={0} failed to {1}:{2}", p2pCon.ID, remoteEndPoint.Address.ToString(), remoteEndPoint.Port));
				}
			}
			return p2pCon;
		}

		/// <summary>
		/// ConnectionManagerɓIPEndPoint̐ڑ悪݂邩ǂ𒲂ׂ郁\bh
		/// </summary>
		/// <param name="con">TcpConnection̎Q</param>
		/// <returns name="exist">݂ꍇtrue</returns>
		private bool Contains(P2PConnection p2pCon) {
			bool exist = false;
			lock(connectionPool.SyncRoot) {//ɃRlNV폜Ȃ悤bN
				foreach(P2PConnection p2pConPool in connectionPool) {
					if(p2pConPool.Connection != null && p2pConPool.Connection.Socket != null) {
						IPEndPoint remoteEndPoint = (IPEndPoint)p2pConPool.Connection.Socket.RemoteEndPoint;
						ConnectionType type = p2pConPool.ConnectionType;
						if(p2pCon.Connection.Socket.RemoteEndPoint == remoteEndPoint &&	p2pCon.ConnectionType == type) {
							exist = true;
							break;
						}
					}
				}
				return exist;
			}
		}

		/// <summary>
		/// ConnectionManagerɓIPAhX̐ڑ悪݂邩ǂ𒲂ׂ郁\bh
		/// </summary>
		/// <param name="servent">Servent</param>
		/// <returns name="exist">݂ꍇtrue</returns>
		private bool Contains(Servent servent, ConnectionType conType) {
			bool exist = false;
			lock(connectionPool.SyncRoot) {//ɃRlNV폜Ȃ悤bN
				foreach(P2PConnection p2pConPool in connectionPool) {
					if(p2pConPool.Servent != null) {
						IPAddress remoteIPAddress = p2pConPool.Servent.Address;
						ConnectionType type = p2pConPool.ConnectionType;
						if(servent.Address.Equals(remoteIPAddress) && conType == type) {
							exist = true;
							break;
						}
					}
				}
				return exist;
			}
		}


		/// <summary>
		/// RlNVv[RlNV폜郁\bh
		/// </summary>
		/// <param name="p2pCon">폜RlNV̎Q</param>
		public void RemoveConnection(P2PConnection p2pCon) {
			p2pCon.Close();
			lock(connectionPool.SyncRoot) {//폜ɃRlNVғȂ悤bN
				connectionPool.Remove(p2pCon);
				p2pCon.Servent.P2PConnection = null;
			}

			Servent servent = p2pCon.Servent;
			model.Log.Write(string.Format("Close P2PConnection ID={0} to {1}:{2}", p2pCon.ID, servent.Address.ToString(), servent.Port));
		}

		/// <summary>
		/// bZ[WM\bh
		/// u[hLXgp
		/// </summary>
		/// <param name="msg">MbZ[W</param>
		public void SendMessage(Message msg) {
			SendMessage(msg, null, false);
		}

		/// <summary>
		/// bZ[WM\bh
		/// </summary>
		/// <param name="msg">MbZ[W</param>
		/// <param name="p2pCon">P2PRlNV</param>
		/// <param name="unicastFlag">jLXgtOBtruȅꍇAw肳ꂽP2PRlNVɂMBfalsȅꍇwȊOɑMB</param>
		public void SendMessage(Message msg, P2PConnection p2pCon, bool unicastFlag) {
			lock(connectionPool.SyncRoot) {//ɃRlNV폜Ȃ悤bN
				if(p2pCon == null) {
					//w肳ꂽbZ[Wu[hLXg
					foreach(P2PConnection con in connectionPool) {
						con.PutMessage(msg);
					}
				} else if(unicastFlag) {
					//w肳ꂽbZ[WjLXg
					if(connectionPool.Contains(p2pCon)) {//RlNVv[ꍇMBꍇ͔jB
						p2pCon.PutMessage(msg);
					}
				} else {
					//w肳ꂽbZ[Ww肳ꂽT[ogȊOɃu[hLXg
					foreach(P2PConnection con in connectionPool) {
						if(con != p2pCon) {
							con.PutMessage(msg);
						}
					}
				}//end if
			}
		}

		/// <summary>
		/// bZ[WM\bh
		/// SendMessage(Message msg, P2PConnection p2pCon, bool unicastFlag)̃I[o[[h
		/// P2PRlNVIDP2PRlNV߂āASendMessage()ɏn
		/// </summary>
		/// <param name="msg">MbZ[W</param>
		/// <param name="p2pConID">P2PRlNVID</param>
		/// <param name="unicastFlag">jLXgtOBtruȅꍇAw肳ꂽP2PRlNVɂMBfalsȅꍇwȊOɑMB</param>
		public void SendMessage(Message msg, int p2pConID, bool unicastFlag) {
			foreach(P2PConnection con in connectionPool) {
				if(con.ID == p2pConID) {
					SendMessage(msg, con, unicastFlag);
					break;
				}
			}
		}

		/// <summary>
		/// T[ogo^NX
		/// zigumonetŊmFłT[og̏ێĂ\bh
		/// </summary>
		/// <param name="servent"></param>
		public void AddServentInfo(Servent servent) {
			serventList.Put(servent);//gL[ƂăLbVɓo^
		}

		/// <summary>
		/// LbVĂ郁bZ[W擾郁\bh
		/// </summary>
		/// <param name="msgID">bZ[WID</param>
		/// <returns>LbVĂꍇAMessageCacheDataNXɂLbVeԂBLbVĂȂꍇnull</returns>
		public MessageCacheData GetCache(Guid msgID) {
			return (MessageCacheData)messageCache.Get(msgID);
		}

		/// <summary>
		/// LbVɃbZ[Wǉ郁\bh
		/// </summary>
		/// <param name="msgID">L[ƂȂ郁bZ[WID</param>
		/// <param name="msgCacheData">ǉf[^</param>
		public object PutCache(Guid msgID, MessageCacheData msgCacheData) {
			return messageCache.Put(msgID, msgCacheData);
		}

		/// <summary>
		/// nhVFCN
		/// serventListQƂAliveȃT[ognhVFCNs
		/// ȂAnhVFCN͍Œڑ𖞂܂ōs
		/// </summary>
		public void HandShake() {
			ArrayList list = serventList.GetArrayList();
			foreach(Servent servent in list) {
				//ŒڑɖȂ@@ȊOT[ogŁ@@ڑ\T[ogŁ@@ɐڑĂIPAhXiIPEndPointł͖IPAhXłBjŖꍇ͐ڑB
				if(CountP2PConnection() < model.MinConnection && !model.MyServent.Equals(servent) && servent.ConnectionEnabledFlag && !Contains(servent, ConnectionType.P2P)) {
					commandController.PutCommand(new SendHandShakeCommand(servent));
					Thread.Sleep(500);//AIɃnhVFCNŝ邽߁AEGCg
				}

			}
		}

		/// <summary>
		/// P2PRlNV邩JEg郁\bh
		/// </summary>
		/// <returns></returns>
		private int CountP2PConnection() {
			int count = 0;
			foreach(P2PConnection p2pCon in connectionPool) {
				if(p2pCon.ConnectionType == ConnectionType.P2P)
					count++;
			}
			return count;
		}

		/// <summary>
		/// liveł낤T[ogXgԂ\bh
		/// </summary>
		/// <returns></returns>
		public ArrayList GetServentList() {
			lock(serventList) {
				return serventList.GetArrayList();
			}
		}
	
		/// <summary>
		/// RlNVI
		/// </summary>
		public void Close() {
			lock(connectionPool.SyncRoot) {//ɃRlNV폜Ȃ悤bN
				//P2PʐMI
				foreach(P2PConnection p2pCon in connectionPool) {
					p2pCon.Close();
				}
				//P2PXi[I
				p2pListenerThread.Close();
				listener.Abort();
			}
		}

		/// <summary>
		/// bZ[WLbVɃLbVCi[NX
		/// </summary>
		public class MessageCacheData {
			/// <summary>
			/// LbV郁bZ[W̎
			/// </summary>
			private int messageType;
			/// <summary>
			/// LbV郁bZ[W͂ǂ̃RlNV痈̂
			/// </summary>
			private int p2pConnectionID;
			/// <summary>
			/// LbV郁bZ[W̔ŝǂ
			/// </summary>
			private bool selfFlag;

			public MessageCacheData(int msgType, int p2pConID) : this(msgType, p2pConID, false) {
			}
			public MessageCacheData(int msgType, int p2pConID, bool flag) {
				messageType = msgType;
				p2pConnectionID = p2pConID;
				selfFlag = flag;
			}
			/// <summary>
			/// bZ[W^CṽvpeB
			/// </summary>
			public int MessageType {
				get {
					return messageType;
				}
				set {
					messageType = value;
				}
			}
			/// <summary>
			/// RlNVID
			/// </summary>
			public int P2PConnectionID {
				get {
					return p2pConnectionID;
				}
				set {
					p2pConnectionID = value;

				}
			}
			/// <summary>
			/// g̔sbZ[W\tÕvpeB
			/// </summary>
			public bool SelfFag {
				get {
					return selfFlag;
				}
				set {
					selfFlag = value;
				}
			}
		}//class MessageCacheData

	}//end ConnectionManager class

}
