/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: BbsCategory.cs,v 1.12 2003/05/25 16:44:07 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.IO;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Threading;
using System.Web;
using System.Windows.Forms;
using System.Xml;

using Zigumo.CommandObject;
using Zigumo.View;

namespace Zigumo.Model
{
	/// <summary>
	/// fNX
	/// f\NX
	/// </summary>
	public class BbsCategory {
		/// <summary>
		/// zigumoJeSURLit@C܂Ŋ܂߂URLj
		/// </summary>
		private ArrayList zigumoUrl = new ArrayList();
		/// <summary>
		/// zigumoJeS̃x[XURLit@C͊܂߂ȂURLj
		/// </summary>
		private ArrayList zigumoBaseUrl = new ArrayList();
		/// <summary>
		/// 2chJeSURLit@C܂Ŋ܂߂URLj
		/// </summary>
		private string bbs2chUrl;
		/// <summary>
		/// 2chJeS̃x[XƂȂURLit@C͊܂߂ȂURLj
		/// </summary>
		private string bbs2chBaseUrl;
		/// <summary>
		/// JeSID
		/// </summary>
		private string categoryID;
		/// <summary>
		/// JeS
		/// </summary>
		private string name;
		/// <summary>
		/// ʃJeS
		/// </summary>
		private string categoryGroup;
		/// <summary>
		/// ݑIĂJeS^u
		/// </summary>
		private BbsCategoryTabPage tabPage;
		/// <summary>
		/// LbVۑpX
		/// </summary>
		private string cacheDirectoryPath;
		/// <summary>
		/// liveȃ`bgT[oi[ĂLbV
		/// </summary>
		private LRUCache chatServerList = new LRUCache(128);
		/// <summary>
		/// XbhXg擾pXbhւ̎Q
		/// </summary>
		private Thread getBbsThreadList;
		/// <summary>
		/// `bgT[oXg擾pXbhւ̎Q
		/// </summary>
		private Thread getChatServerList;
		/// <summary>
		/// XbhXgr[NAfQ[g
		/// </summary>
		private delegate void ClearBbsThreadListDelegate();
		/// <summary>
		/// XbhXgr[XVfQ[g
		/// </summary>
		private delegate void UpdateBbsThreadListDelegate(BbsThread bbsThread, Thread thread);
		/// <summary>
		/// Xe[^Xo[XVfQ[g
		/// </summary>
		private delegate void SetStatusBarDelegate(string text);

		/// <summary>
		/// zigumo URL̃vpeBit@C܂߂URLj
		/// </summary>
		public ArrayList ZigumoUrl {
			get {
				return zigumoUrl;
			}
			set {
				zigumoUrl = value;
			}
		}
		/// <summary>
		/// zigumo BaseURL̃vpeBit@C܂߂ȂURLj
		/// </summary>
		public ArrayList ZigumoBaseUrl {
			get {
				return zigumoBaseUrl;
			}
			set {
				zigumoBaseUrl = value;
			}
		}		/// <summary>
		/// URL̃vpeBit@C܂߂URLj
		/// </summary>
		public string Bbs2chUrl {
			get {
				return bbs2chUrl;
			}
			set {
				bbs2chUrl = value;
			}
		}
		/// <summary>
		/// BaseURL̃vpeBit@C܂߂ȂURLj
		/// </summary>
		public string Bbs2chBaseUrl {
			get {
				return bbs2chBaseUrl;
			}
			set {
				bbs2chBaseUrl = value;
			}
		}
		/// <summary>
		/// JeSID̃vpeB
		/// </summary>
		public string CategoryID {
			get {
				if(categoryID == null || categoryID == "") {
					//JeSID̐
					//JeSID̓O[v.JeSMD5nbVƂȂB
					//Ⴆ΁uj[XvO[v́uj[X+v̏ꍇA
					//uj[X.j[X+v̕ƂMD5nbV
					//邱ƂɂȂB
					//ȂAMD5nbVUTF8ɂB
					MD5 md5 = new MD5CryptoServiceProvider();
					byte[] data = Encoding.UTF8.GetBytes(categoryGroup + "." + name);
					byte[] result = md5.ComputeHash(data);
					StringBuilder strBuff = new StringBuilder();
					foreach(byte r in result)
						strBuff.Append(string.Format("{0:x2}", r));

					categoryID = strBuff.ToString();
				}
				return categoryID;
			}
			set {
				categoryID = value;
			}
		}
		/// <summary>
		/// JeS̃vpeB
		/// </summary>
		public string Name {
			get {
				return name;
			}
			set {
				name = value;
			}
		}
		/// <summary>
		/// JeSO[ṽvpeB
		/// </summary>
		public string CategoryGroup {
			get {
				return categoryGroup;
			}
			set {
				categoryGroup = value;
			}
		}
		/// <summary>
		/// ݑIĂ^ũvpeB
		/// </summary>
		public BbsCategoryTabPage TabPage {
			get {
				return tabPage;
			}
			set {
				tabPage = value;
			}
		}

		public BbsCategory() {
		}

		/// <summary>
		/// Xbhe\郁\bh
		/// </summary>
		public void UpdateCategory() {
			getBbsThreadList = new Thread(new ThreadStart(GetBbsThreadList));
			getBbsThreadList.Start();
		}

		/// <summary>
		/// JeSXg擾
		/// </summary>
		public void GetBbsThreadList() {
			ZigumoModel model = ZigumoModel.Model;

			//Xe[^Xo[XV
			SetStatusBarDelegate setStatusBarDelegate = new SetStatusBarDelegate(model.Form.SetStatusBar);
			object[] obj = { "XbhꗗXV..." };
			model.Form.BeginInvoke(setStatusBarDelegate, obj);

			//\^ȕу^uy[W䌠̎擾
			SetTabPageControlPermission();
			
			model.Log.Write("Get Thread list from " + bbs2chUrl);

			//BBS̎ނɂ킹Ď擾ς
			if(tabPage.BbsType == BbsType.Zigumo) {
				GetBbsZigumoThreadList();
			} else if(tabPage.BbsType == BbsType.Bbs2ch) {
				GetBbs2chThreadList();
			}

			//Xe[^Xo[NA
			obj = new object[] {""};
			model.Form.BeginInvoke(setStatusBarDelegate, obj);
		}

		/// <summary>
		/// zigumoXbhXg擾\bh
		/// </summary>
		private void GetBbsZigumoThreadList() {
			ZigumoModel model = ZigumoModel.Model;

			//ۑt@C̐ݒ
			this.cacheDirectoryPath = model.CacheDirectoryPath + "zigumo/" + CategoryID + "/";
			if(!Directory.Exists(this.cacheDirectoryPath)) {//fBNgꍇ͍쐬
				Directory.CreateDirectory(this.cacheDirectoryPath);
			}
//bookmark 20030522

			//擾URL̐ݒ
			string url = null;
			//擾URL邩ǂ
			if(zigumoBaseUrl == null || zigumoBaseUrl.Count <= 0) {
				//zigumoT[oݒ肳ĂȂ|̕\Xe[^Xo[ɍs
				SetStatusBarDelegate setStatusBarDelegate = new SetStatusBarDelegate(model.Form.SetStatusBar);
				object[] obj = { "zigumoJeS̃T[oݒ肳Ă܂B" };
				model.Form.BeginInvoke(setStatusBarDelegate, obj);

				return;
			} else {
				url = (string)zigumoBaseUrl[0];//Ƃ肠擪URL擾悤ɂB
			}


			//擾Jn
			Stream st = null;
			StreamReader sr = null;
			FileStream   fs = null;
			StreamWriter sw = null;
			try {
				HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(url);
				httpReq.UserAgent = "Monazilla/1.00 (" + model.ZigumoUserAgent + ")";
				HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();
				st = httpRes.GetResponseStream();

				//Content-Type̎擾
				//Content-TypȅԂɂď𕪂
				string contentType = httpRes.ContentType;
				if(contentType == "text/html" || contentType == "text/plain") {
					//eLXg`Ńf[^Ăꍇ
					//f[^̓G[Ƃď
					string textLine = null;
					sr = new StreamReader(st, Encoding.GetEncoding("Shift_JIS"));
					while ((textLine = sr.ReadLine()) != null) {
						if(textLine.IndexOf("error") > -1) 
							model.Log.Write("Thread list get error " + url);
						return;
					}
					
				}
// bookmark 20030526
				//XML`Ńf[^Ăꍇ
				//f[^̓XbhXgƂď
				XmlTextReader rdr = new XmlTextReader(st);
				while(rdr.Read()) {
					switch (rdr.NodeType) {
						case XmlNodeType.Element:
							if(rdr.Name == "thread") {
								Console.WriteLine("Thread start");
								//Xbh̎擾
								while (rdr.MoveToNextAttribute()) {
									if(rdr.Name == "id") {
										Console.WriteLine("Id=" + rdr.Value);
									} else if(rdr.Name == "title") {
										Console.WriteLine("Title=" + rdr.Value);
									} else if(rdr.Name == "rescount") {
										Console.WriteLine("ResCount=" + rdr.Value);
									}
								}
							}
							break;
						case XmlNodeType.EndElement:
							if(rdr.Name == "thread") {
								//Xbh̒ǉ
//								TreeNode newNode = new TreeNode(category.Name, 1, 1);
//								newNode.Tag = category;
//								node.Nodes.Add(newNode);
							}
							break;

					}

				}
				rdr.Close();
				



				
				//擾XbhXgXMLt@Cɕۑ
//				string file = cacheDirectoryPath + "threadlist.xml";

				fs = new FileStream("testfile.txt", FileMode.Append);
				sw = new StreamWriter(fs, Encoding.UTF8);


//				int number = 1;
//				string itemText = null;
//				tabPage.BeginUpdate();//h~̂߉ʕ`揈̒~
//				while ((itemText = sr.ReadLine()) != null) {
//					//XbhIuWFNg
//					BbsThread bbsThread = new Bbs2chThread(this, itemText);
//					bbsThread.Number = number++;
//					bbsThread.LoadBbsThreadInfo();
//
//					//XMLŕۑ
//					xw.WriteStartElement("thread");
//					xw.WriteAttributeString("id", bbsThread.ThreadID);
//					xw.WriteAttributeString("title", bbsThread.Title);
//					xw.WriteAttributeString("resnum", bbsThread.ResNum.ToString());
//					xw.WriteEndElement();
//					
//					//ʍXV
//					UpdateBbsThreadListDelegate updateBbsThreadListDelegate = new UpdateBbsThreadListDelegate(tabPage.UpdateCategoryTabView);
//					object[] obj = new object[] {bbsThread, Thread.CurrentThread};
//					model.Form.BeginInvoke(updateBbsThreadListDelegate, obj);
//					if (model.NumberOfThreadsToUpdateUI != 0)
//						tabPage.EndUpdate();//ʍXV
//				}
//				tabPage.EndUpdate();//ʕ`揈̍ĊJ

			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
//				if(xw != null) {
//					xw.WriteEndElement();
//					xw.Close();
//				}
				sw.Close();
				fs.Close();
				sr.Close();
				st.Close();
			}

//			Stream st = null;
//			StreamReader sr = null;
//			XmlTextWriter xw = null;
//			try {
//				HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(bbs2chUrl);
//				httpReq.UserAgent = "Monazilla/1.00 (" + model.ZigumoUserAgent + ")";
//				HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();
//
//				//Xg[oRŎ擾
//				st = httpRes.GetResponseStream();
//				sr = new StreamReader(st, Encoding.GetEncoding("Shift_JIS"));
//
//				//擾XbhXgXMLt@Cɕۑ
//				string file = cacheDirectoryPath + "threadlist.xml";
//				xw = new XmlTextWriter(file, Encoding.UTF8);
//				xw.Formatting = Formatting.Indented;
//				xw.WriteStartDocument();
//				xw.WriteStartElement("category");
//				xw.WriteAttributeString("name", name);
//				xw.WriteAttributeString("id", CategoryID);
//
//				int number = 1;
//				string itemText = null;
//				tabPage.BeginUpdate();//h~̂߉ʕ`揈̒~
//				while ((itemText = sr.ReadLine()) != null) {
//					//XbhIuWFNg
//					BbsThread bbsThread = new Bbs2chThread(this, itemText);
//					bbsThread.Number = number++;
//					bbsThread.LoadBbsThreadInfo();
//
//					//XMLŕۑ
//					xw.WriteStartElement("thread");
//					xw.WriteAttributeString("id", bbsThread.ThreadID);
//					xw.WriteAttributeString("title", bbsThread.Title);
//					xw.WriteAttributeString("resnum", bbsThread.ResNum.ToString());
//					xw.WriteEndElement();
//					
//					//ʍXV
//					UpdateBbsThreadListDelegate updateBbsThreadListDelegate = new UpdateBbsThreadListDelegate(tabPage.UpdateCategoryTabView);
//					object[] obj = new object[] {bbsThread, Thread.CurrentThread};
//					model.Form.BeginInvoke(updateBbsThreadListDelegate, obj);
//					if (model.NumberOfThreadsToUpdateUI != 0)
//						tabPage.EndUpdate();//ʍXV
//				}
//				tabPage.EndUpdate();//ʕ`揈̍ĊJ
//
//			} catch(IOException e) {
//				Console.WriteLine(e);
//				Console.WriteLine(e.StackTrace);
//			} finally {
//				if(xw != null) {
//					xw.WriteEndElement();
//					xw.Close();
//				}
//				sr.Close();
//				st.Close();
//			}
		}

		private void ReadXmlThreadList() {
		}


		/// <summary>
		/// QXbhXg擾\bh
		/// </summary>
		private void GetBbs2chThreadList() {
			ZigumoModel model = ZigumoModel.Model;

			//ۑt@C̐ݒ
			this.cacheDirectoryPath = model.CacheDirectoryPath + "2ch/" + CategoryID + "/";
			if(!Directory.Exists(this.cacheDirectoryPath)) {//fBNgꍇ͍쐬
				Directory.CreateDirectory(this.cacheDirectoryPath);
			}

			Stream st = null;
			StreamReader sr = null;
			XmlTextWriter xw = null;
			try {
				HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(bbs2chUrl);
				httpReq.UserAgent = "Monazilla/1.00 (" + model.ZigumoUserAgent + ")";
				HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();

				//Xg[oRŎ擾
				st = httpRes.GetResponseStream();
				sr = new StreamReader(st, Encoding.GetEncoding("Shift_JIS"));

				//擾XbhXgXMLt@Cɕۑ
				string file = cacheDirectoryPath + "threadlist.xml";
				xw = new XmlTextWriter(file, Encoding.UTF8);
				xw.Formatting = Formatting.Indented;
				xw.WriteStartDocument();
				xw.WriteStartElement("category");
				xw.WriteAttributeString("name", name);
				xw.WriteAttributeString("id", CategoryID);

				int number = 1;
				string itemText = null;
				tabPage.BeginUpdate();//h~̂߉ʕ`揈̒~
				while ((itemText = sr.ReadLine()) != null) {
					//XbhIuWFNg
					BbsThread bbsThread = new Bbs2chThread(this, itemText);
					bbsThread.Number = number++;
					bbsThread.LoadBbsThreadInfo();

					//XMLŕۑ
					xw.WriteStartElement("thread");
					xw.WriteAttributeString("id", bbsThread.ThreadID);
					xw.WriteAttributeString("title", bbsThread.Title);
					xw.WriteAttributeString("resnum", bbsThread.ResNum.ToString());
					xw.WriteEndElement();
					
					//ʍXV
					UpdateBbsThreadListDelegate updateBbsThreadListDelegate = new UpdateBbsThreadListDelegate(tabPage.UpdateCategoryTabView);
					object[] obj = new object[] {bbsThread, Thread.CurrentThread};
					model.Form.BeginInvoke(updateBbsThreadListDelegate, obj);
					if (model.NumberOfThreadsToUpdateUI != 0)
						tabPage.EndUpdate();//ʍXV
				}
				tabPage.EndUpdate();//ʕ`揈̍ĊJ

			} catch(IOException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
				if(xw != null) {
					xw.WriteEndElement();
					xw.Close();
				}
				sr.Close();
				st.Close();
			}
		}

		/// <summary>
		/// \ׂ^uy[W̐䌠擾
		/// </summary>
		private void SetTabPageControlPermission() {
			//\^ȕу^uy[W䌠̎擾
			lock(tabPage) {
				tabPage.BbsCategory = this;//^u䌠̐ݒ

				//Xg̃NA
				ClearBbsThreadListDelegate clearBbsThreadList = new ClearBbsThreadListDelegate(this.tabPage.ClearListView);
				tabPage.BeginInvoke(clearBbsThreadList);

				//̂̐ݒ
				tabPage.Text = name;
				tabPage.Thread = Thread.CurrentThread;
			}
		}

		/// <summary>
		/// YJeSɑ݂`bgT[oXgXV郁\bh
		/// </summary>
		public void UpdateChatServerList() {
			getChatServerList = new Thread(new ThreadStart(GetChatServerList));
			getChatServerList.Start();
		}

		/// <summary>
		/// `bgT[oXg擾郁\bh
		/// </summary>
		private void GetChatServerList() {
		}
	}//end class
}
