/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: BbsThread.cs,v 1.6 2003/05/05 17:15:25 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;

using Zigumo.CommandObject;
using Zigumo.Network;
using Zigumo.View;

namespace Zigumo.Model
{
	/// <summary>
	/// BBSXbhNX
	/// </summary>
	public abstract class BbsThread
	{
		/// <summary>
		/// Xbhꗗ\No.
		/// </summary>
		protected int number;
		/// <summary>
		/// Xbh^Cg
		/// </summary>
		protected string title;
		/// <summary>
		/// X
		/// \̃X
		/// </summary>
		protected int resnum = 1;
		/// <summary>
		/// 擾ς݂ŕۑĂ郌X
		/// </summary>
		protected int savedResnum;
		/// <summary>
		/// XbhID
		/// </summary>
		protected string threadID = "";
		/// <summary>
		/// Xbh擾URL
		/// </summary>
		protected string url;
		/// <summary>
		/// ݎ擾ς݂̃TCY
		/// </summary>
		protected int size;
		/// <summary>
		/// Xbh̏JeS
		/// </summary>
		protected BbsCategory category;
		/// <summary>
		/// ̃Xbhɑ郌Xꗗ
		/// </summary>
		protected ArrayList resList = new ArrayList();
		/// <summary>
		/// Xǂ܂œǂݍł邩JE^
		/// ̃f[^Ƃĉǂ݂ł邩\B
		/// </summary>
		protected int currentResnum = 1;
		/// <summary>
		/// \̍ۂɎgp^uy[W
		/// </summary>
		protected BbsThreadTabPage tabPage;
		/// <summary>
		/// BbsThread擾Xbhւ̎Q
		/// </summary>
		protected Thread getBbsThread;
		/// <summary>
		/// uNy[WirQ[gfQ[g
		/// </summary>
		public delegate void NavigateBlankDelegate();
		/// <summary>
		/// XbhXVfQ[g
		/// </summary>
		public delegate void UpdateBbsThreadDelegate(BbsRes res, bool newFlag, Thread thread);
		/// <summary>
		/// XbhXgACeXVfQ[g
		/// </summary>
		public delegate void UpdateItemDelegate(BbsThread bbsThread);
		/// <summary>
		/// \XWvfQ[g
		/// </summary>
		public delegate void JumpResDelegate(string label);
		/// <summary>
		/// Xe[^Xo[XVfQ[g
		/// </summary>
		public delegate void SetStatusBarDelegate(string text);
		
		/// <summary>
		/// No.̃vpeB
		/// </summary>
		public int Number {
			get {
				return number;
			}
			set {
				number = value;
			}
		}
		/// <summary>
		/// ^Cg̃vpeB
		/// </summary>
		public string Title {
			get {
				return title;
			}
			set {
				title = value;
			}
		}
		/// <summary>
		/// X̃vpeB
		/// </summary>
		public int ResNum {
			get {
				return resnum;
			}
			set {
				resnum = value;
			}
		}
		/// <summary>
		/// XbhID̃vpeB
		/// </summary>
		public string ThreadID {
			get {
				return threadID;
			}
			set {
				threadID = value;
			}
		}
		/// <summary>
		/// Xbh擾URL
		/// </summary>
		public string Url {
			get {
				return url;
			}
			set {
				url = value;
			}
		}
		/// <summary>
		/// t@C̃vpeB
		/// </summary>
		public string FileName {
			get {
				return threadID + ".dat";
			}
		}
		/// <summary>
		/// t@CۑpX̃vpeB
		/// </summary>
		public string CacheDirectoryPath {
			get {
				string cacheDirectoryPath = ZigumoModel.Model.CacheDirectoryPath + "2ch/";
				if(category != null)
					cacheDirectoryPath += category.CategoryID + "/";
				return cacheDirectoryPath;
			}
		}
		/// <summary>
		/// t@Cۑ̃tpX
		/// </summary>
		public string FilePath {
			get {
				return CacheDirectoryPath + FileName;
			}
		}
		/// <summary>
		/// 擾ς݃TCỸvpeB
		/// </summary>
		public int Size {
			get {
				return size;
			}
			set {
				size = value;
			}
		}
		/// <summary>
		/// JeS̃vpeB
		/// </summary>
		public BbsCategory Category {
			get {
				return category;
			}
			set {
				category = value;
			}
		}
		/// <summary>
		/// ݂ǂ܂ŃŎ擾\currentResnum̃vpeB
		/// </summary>
		public int CurrentResNum {
			get {
				return currentResnum;
			}
			set {
				currentResnum = value;
			}
		}
		/// <summary>
		/// \̍ۂɎgp^uy[W̃vpeB
		/// </summary>
		public BbsThreadTabPage TabPage {
			get {
				return tabPage;
			}
			set {
				tabPage = value;
			}
		}
		/// <summary>
		/// XXg̃vpeB
		/// </summary>
		public ArrayList ResList {
			get {
				return resList;
			}
			set {
				resList = value;
			}
		}
		/// <summary>
		/// Xւ̃CfNT
		/// </summary>
		public BbsRes this[int index] {
			get {
				return (BbsRes)resList[index];
			}
			set {
				resList[index] = value;
			}
		}

		public BbsThread() {
		}

		public BbsThread(BbsCategory category, string text) {
			this.category = category;

			try {
				//p[X
				string id = text.Substring(0, text.IndexOf("."));
				int startIndex = text.IndexOf("<>") + 2;
				string title = text.Substring(startIndex, text.LastIndexOf(" (") - startIndex);
				startIndex = text.LastIndexOf(" (") + 2;
				int resnum = Convert.ToInt32(text.Substring(startIndex, text.Length - startIndex - 1));

				this.category = category;
				this.threadID = id;
				this.url = category.Bbs2chBaseUrl + "dat/" + id + ".dat";
				this.title = title;
				this.resnum = resnum;
			} catch(Exception) {
				this.category = category;
				this.threadID = "-";
				this.url = "";
				this.title = "ǂݍ݃G[";
				this.resnum = 0;
			}
		}

		/// <summary>
		/// XbhNX̓eListViewItemNXɕϊ郁\bh
		/// </summary>
		/// <returns></returns>
		public ListViewItem GetListViewItem() {
			ListViewItem item = new ListViewItem();
			item.Tag = this;
			item.SubItems.Add(number.ToString());
			item.SubItems.Add(title);
			item.SubItems.Add(resnum.ToString());
			item.SubItems.Add(savedResnum.ToString());
			item.SubItems.Add("");
			item.SubItems.Add("");
			item.SubItems.Add(category.Name);//JeS
			item.SubItems.Add(threadID);//ID
			
			if(savedResnum > 0)
				item.ImageIndex = 0;//`FbN}[NACR\

			if(resnum > savedResnum && savedResnum > 0)
				item.ImageIndex = 1;//AbvACR\

			return item;
		}

		/// <summary>
		/// Xbhe\郁\bh
		/// </summary>
		public abstract void UpdateThread();

		/// <summary>
		/// Xbh擾\郁\bh
		/// </summary>
		public abstract void GetBbsThread();

		/// <summary>
		/// tabPage䌏̎擾
		/// </summary>
		protected void SetTabPageControlPermission() {
			lock(tabPage) {
				//^uy[W䌠̐ݒ
				tabPage.Thread = Thread.CurrentThread;

				//\ĂXbhƈႤXbh\ꍇ͈xNAB
				if(tabPage.BbsThread == null || tabPage.BbsThread.threadID != threadID) {
					//^uɎݒ
					tabPage.BbsThread = this;

					//uNy[W\
					tabPage.HtmlDocument = null;//htmlDocumentBtabPage.NavigateBlanksɒl͐ݒ肳B
					NavigateBlankDelegate navigateBlankDelegate = new NavigateBlankDelegate(tabPage.NavigateBlank);
					tabPage.BeginInvoke(navigateBlankDelegate);

					//htmlDocument̒lݒ肳܂ŁA҂B
					//htmlDocument̒laxWebBrowser_DocumentCompleteŐݒ肳B
					int count = 0;
					while(tabPage.HtmlDocument == null) {
						Thread.Sleep(10);
						if(count++ > 300) {
							System.Windows.Forms.MessageBox.Show("uEU݃G[");
							return;
						}//end if
					}//end while
				}//end if
			}//end lock
		}

		/// <summary>
		/// Xbh̓ǂݍ
		/// </summary>
		public abstract void LoadBbsThreadInfo();

		/// <summary>
		/// ۑĂ郌X̓ǂݍ
		/// </summary>
		protected abstract void LoadBbsRes();

		/// <summary>
		/// X̏
		/// </summary>
		protected void WriteRes(BbsRes res, bool newFlag) {
			//X݃fQ[gN
			UpdateBbsThreadDelegate updateBbsThreadDelegate = new UpdateBbsThreadDelegate(tabPage.WriteRes);
			object[] obj = {res, newFlag, Thread.CurrentThread};
			tabPage.BeginInvoke(updateBbsThreadDelegate, obj);
		}

		/// <summary>
		/// XbhXgACeXV\bh
		/// </summary>
		protected void UpdateItem() {
			ZigumoModel model = ZigumoModel.Model;

			UpdateItemDelegate updateItemDelegate = new UpdateItemDelegate(model.Form.SelectedBbsCategoryTabPage.UpdateItem);
			object[] obj = new object[] {this};
			model.Form.SelectedBbsCategoryTabPage.BeginInvoke(updateItemDelegate, obj);
		}

		/// <summary>
		/// X\ʒuWv\bh
		/// </summary>
		/// <param name="label"></param>
		protected void JumpRes(string label) {
			JumpResDelegate jumpResDelegate = new JumpResDelegate(tabPage.JumpRes);
			object[] obj = {label};
			tabPage.BeginInvoke(jumpResDelegate, obj);
		}

		/// <summary>
		/// Xe[^Xo[XV\bh
		/// </summary>
		/// <param name="text">Xe[^Xo[ɕ\</param>
		protected void SetStatusBar(string text) {
			ZigumoModel model = ZigumoModel.Model;

			//Xe[^Xo[XV
			SetStatusBarDelegate setStatusBarDelegate = new SetStatusBarDelegate(model.Form.SetStatusBar);
			object[] obj = { text };
			model.Form.BeginInvoke(setStatusBarDelegate, obj);
		}

	}//end class
}
