/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: LRUCache.cs,v 1.9 2003/04/25 03:06:50 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;

namespace Zigumo.Model
{
	/// <summary>
	/// LRU(Least Recently Used algorithm)ŃIuWFNgLbVNX
	/// HashtableNXƓƎXg`ŎB
	/// XbhZ[tB
	/// </summary>
	public class LRUCache
	{
		/// <summary>
		/// LbVTCY
		/// ō̃IuWFNgo^ł邩\
		/// </summary>
		private int maxDataSize;
		/// <summary>
		/// LbVf[^i[nbVe[u
		/// </summary>
		private Hashtable hashTable;
		/// <summary>
		/// LbVf[^Xg\ŎƂ
		/// ̃Xg̐擪w|C^
		/// </summary>
		private Bucket head = null;
		/// <summary>
		/// LbVf[^Xg\ŎƂ
		/// ̃Xg̍Ōw|C^
		/// </summary>
		private Bucket tail = null;

		public LRUCache(int size) {
			maxDataSize = size;
			hashTable = new Hashtable(size);
		}
		
		/// <summary>
		/// f[^ǉ
		/// L[Af[^ƂꍇɎg\bh
		/// </summary>
		/// <param name="data"></param>
		/// <returns></returns>
		public object Put(object data) {
			return Put(data, data);
		}

		/// <summary>
		/// f[^ǉ
		/// f[^݂ꍇ͂̃f[^擪ɈړÃf[^߂lƂĕԂ
		/// </summary>
		/// <param name="key">f[^̃L[</param>
		/// <param name="data">ǉf[^</param>
		/// <returns>݂f[^Bf[^݂Ȃꍇnull</returns>
		public object Put(object key, object data) {
			lock(this) {
				object result = Get(key);//f[^邩ǂ`FbN
				
				if(result == null) {
					//f[^ꍇ͒ǉ
					Bucket bucket = new Bucket(key, data);//f[^͂̃NXp̃oPbgɓĊǗ
					hashTable[key] = bucket;
					this.AddBucket(bucket);
				
					//LbVTCYwʂ𒴂ꍇAłgĂȂNX폜
					if(hashTable.Count > maxDataSize)
						Remove();
				} else {
					//f[^ꍇdataXV
					Bucket bucket = head;
					bucket.data = data;
				}

				return result;
			}
		}

		/// <summary>
		/// Get̃I[o[[h
		/// </summary>
		/// <param name="key">擾f[^̃L[</param>
		/// <returns>擾f[^B擾łȂꍇnull</returns>
		public object Get(object key) {
			return Get(key, true);
		}

		/// <summary>
		/// L[f[^擾邽߂̃\bh
		/// 擾ꂽf[^͐擪Ɉړ
		/// </summary>
		/// <param name="key">擾f[^̃L[</param>
		/// <param name="lruFlag">LRUtOBtruȅꍇLRUANZXBfalsȅꍇԂւȂANZXB</param>
		/// <returns></returns>
		public object Get(object key, bool lruFlag) {
			lock(this) {
				object result = null;
				if(lruFlag) {
					//LRUŃf[^o
					Bucket bucket = (Bucket)hashTable[key];
					if(bucket == null)
						return null;

					result = bucket.data;

					//oPbgXg폜Đ擪ɎĂ
					if(bucket.previous != null)
						bucket.previous.next = bucket.next;
					if(bucket.next != null)
						bucket.next.previous = bucket.previous;
					if(tail == bucket && bucket.previous != null)
						tail = bucket.previous;

					bucket.previous = null;
					if(head != bucket) {
						bucket.next = head;
						head.previous = bucket;
					}
					head = bucket;
				} else {
					//f[^ȍ
					result = ((Bucket)hashTable[key]).data;
				}
				return result;
			}
		}

		/// <summary>
		/// L[擪ɒǉ
		/// </summary>
		/// <param name="dataBucket">ǉf[^bvĂdataBucket</param>
		private void AddBucket(Bucket bucket) {
			bucket.previous = null;
			bucket.next = head;
			if(head == null)
				tail = bucket;
			else
				head.previous = bucket;
			head = bucket;
		}

		/// <summary>
		/// łgĂȂf[^폜
		/// </summary>
		private void Remove() {
			if(tail == null)
				return;

			//Ō̃L[擾
			object key = tail.key;

			//Ō폜
			if(tail.previous != null)
				tail.previous.next = null;
			tail = tail.previous;

			//擾L[ɂf[^폜
			hashTable.Remove(key);
		}

		/// <summary>
		/// i[Ăf[^ArrayListɂĕԂ
		/// </summary>
		/// <returns></returns>
		public ArrayList GetArrayList() {
			lock(this) {
				if(head == null)
					return null;

				ArrayList list = new ArrayList();

				Bucket current = head;
				do {
					list.Add(current.data);
					current = current.next;
				} while(current != null);

				return list;
			}
		}

		/// <summary>
		/// f[^i[oPbg
		/// LbVf[^Ƃ̃L[XgƂĕێ邽߂̃oPbg
		/// </summary>
		private class Bucket {
			/// <summary>
			/// BucketɃbvf[^̃L[
			/// </summary>
			public object key;
			/// <summary>
			/// BucketɃbvf[^
			/// </summary>
			public object data;
			/// <summary>
			/// ̑OɈʒuoPbg
			/// </summary>
			public Bucket previous = null;
			/// <summary>
			/// ̌ɈʒuoPbg
			/// </summary>
			public Bucket next = null;

			public Bucket(object key, object data) {
				this.key = key;
				this.data = data;
			}
		}
	}
}
