/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: AbstractListenerThread.cs,v 1.4 2003/04/24 18:11:42 hoge-taicho Exp $
 * 
 */

using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Windows.Forms;

using Zigumo.CommandObject;
using Zigumo.Network;

namespace Zigumo.Network
{
	/// <summary>
	/// TCPXi[NX
	/// </summary>
	public abstract class AbstractListenerThread
	{
		/// <summary>
		/// Xi[
		/// </summary>
		protected TcpListener tcpListener;
		
		/// <summary>
		/// Xi[gp|[gԍ
		/// </summary>
		protected int portNumber;

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="port">Xi[gp|[gԍ</param>
		public AbstractListenerThread(int port)
		{
			portNumber = port;
		}

		/// <summary>
		/// Xi[
		/// </summary>
		public void StartUp() {
			try {
				tcpListener = new TcpListener(IPAddress.Any, portNumber);
				tcpListener.Start();
			} catch(ArgumentOutOfRangeException) {
				throw;
			} catch(SocketException) {
				throw;
			}

		}

		/// <summary>
		/// bXJn
		/// </summary>
		public void Listen() {
			while(true) {
				try {
					Accept();
				} catch(SocketException) {
					break;
				} catch(ThreadAbortException) {
					break;
				}
			}
		}

		/// <summary>
		/// M
		/// </summary>
		protected abstract void Accept();

		/// <summary>
		/// Xi[I\bh
		/// </summary>
		public void Close() {
			tcpListener.Stop();
		}

	}
}
