/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: P2PConnection.cs,v 1.12 2003/04/25 03:07:00 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

using Zigumo.CommandObject;
using Zigumo.Network;
using Zigumo.MessageObject;
using Zigumo.Model;

namespace Zigumo.Network
{
	/// <summary>
	/// zigumoɂāÃT[ogƂP2PRlNV\NX
	/// </summary>
	public class P2PConnection {
		/// <summary>
		/// ۂ̐ڑ\TcpConnectionNX
		/// </summary>
		private TcpConnection connection;
		/// <summary>
		/// ڑ̃Xg[
		/// </summary>
		private NetworkStream networkStream;
		/// <summary>
		/// fւ̎Q
		/// </summary>
		private ZigumoModel model;
		/// <summary>
		/// R}hRg[ւ̎Q
		/// </summary>
		private CommandController commandController;
		/// <summary>
		/// RlNV}l[Wւ̎Q
		/// </summary>
		private ConnectionManager connectionManager;
		/// <summary>
		/// RlNVւ̑MbZ[Wi[郁bZ[WL[
		/// </summary>
		private Queue messageQueue;
		/// <summary>
		/// MpXbhւ̎Q
		/// </summary>
		private Thread sendMessageThread;
		/// <summary>
		/// MpXbhւ̎Q
		/// </summary>
		private Thread receiveMessageThread;
		/// <summary>
		/// MXbhpEFCgCxg
		/// </summary>
		private AutoResetEvent waitEvent;
		/// <summary>
		/// RlNV^Cv
		/// </summary>
		private ConnectionType connectionType;
		/// <summary>
		/// RlNV^Cv̕\`
		/// </summary>
		private static Hashtable ConType = new Hashtable();
		/// <summary>
		/// bZ[Wpobt@
		/// </summary>
		private Message message = new Message(Message.headerSize);
		/// <summary>
		/// ڑT[og̏
		/// </summary>
		private Servent servent;
		/// <summary>
		/// MtO
		/// ̃RlNVnhVFCNMĐꂽ̂ǂ\B
		/// MĐꂽRlNV̏ꍇtrue
		/// </summary>
		private bool passiveFlag = false;
		/// <summary>
		/// RlNVID
		/// </summary>
		private int id;
		/// <summary>
		/// RlNVIDpV[PXԍ
		/// </summary>
		private static int connectionSequenceID = 0;		

		/// <summary>
		/// P2PRlNVŎۂTcpConnectionNXŕ\ꂽRlNVւ̃vpeB
		/// </summary>
		public TcpConnection Connection {
			get {
				return connection;
			}
			set {
				connection = value;
			}
		}
		/// <summary>
		/// RlNV[hvpeB
		/// </summary>
		public ConnectionType ConnectionType {
			get {
				return connectionType;
			}
			set {
				connectionType = value;
			}
		}
		/// <summary>
		/// RlNV[h𕪂₷ŕԂ
		/// </summary>
		public string ConTypeToString {
			get {
				return (string)ConType[connectionType];
			}
		}
		/// <summary>
		/// ڑGh|Cg̃vpeB
		/// </summary>
		public Servent Servent {
			get {
				return servent;
			}
			set {
				servent = value;
				servent.P2PConnection = this;
			}
		}
		/// <summary>
		/// IDvpeB
		/// </summary>
		public int ID {
			get {
				return id;
			}
			set {
				id = value;
			}
		}
		/// <summary>
		/// IDV[PXvpeB
		/// </summary>
		public int SequenceID {
			get {
				int id;
				lock(this) {
					id = connectionSequenceID++;
					if(connectionSequenceID > 999999999)
						connectionSequenceID = 0;
				}
				return id;
			}
		}

		static P2PConnection() {
			//RlNV^Cvݒ
			ConType[ConnectionType.None] = "-";
			ConType[ConnectionType.P2P] = "P2Pڑ";;
			ConType[ConnectionType.Chat] = "Chatڑ";
		}

		public P2PConnection(TcpConnection con, NetworkStream ns) : this(con, ns, ConnectionType.P2P, false) {
		}

		public P2PConnection(TcpConnection con, NetworkStream ns, bool pFlag) : this(con, ns, ConnectionType.P2P, pFlag) {
		}

		public P2PConnection(TcpConnection con, NetworkStream ns, ConnectionType conType, bool pFlag) {
			//Xg[̐ݒ
			connection = con;
			networkStream = ns;
			if(networkStream == null) {
				try {
					networkStream = con.GetStream();
				} catch(Exception e) {
					Console.WriteLine(e);
					Console.WriteLine(e.StackTrace);
				}
			}
			connectionType = conType;
			passiveFlag = pFlag;

			model = ZigumoModel.Model;
			commandController = CommandController.Controller;
			connectionManager = ConnectionManager.Manager;
			waitEvent = new AutoResetEvent(false);
			messageQueue = new Queue();

			//T[og̐ݒ
			servent = new Servent((IPEndPoint)this.connection.Socket.RemoteEndPoint, DateTime.Now);
			servent.P2PConnection = this;
			servent.ConnectionEnabledFlag = !pFlag;//MڑƂĎn܂ꍇ͐ڑł邩ǂȂ̂false
			connectionManager.AddServentInfo(servent);

			//fobOpɃRlNVʂ邽߂IDݒ
			id = SequenceID;

			//MpXbh
			sendMessageThread = new Thread(new ThreadStart(this.SendMessageThread));
			sendMessageThread.Name = "ReceiveThread " + id.ToString();

			//MpXbh
			receiveMessageThread = new Thread(new ThreadStart(this.ReceiveMessageThread));
			receiveMessageThread.Name = "SendThread " + id.ToString();
		}

		/// <summary>
		/// XbhX^[g\bh
		/// </summary>
		public void StartThread() {
			sendMessageThread.Start();
			receiveMessageThread.Start();
		}

		/// <summary>
		/// MbZ[Wݒ胁\bh
		/// </summary>
		/// <param name="msg">MbZ[W</param>
		public void PutMessage(Message msg) {
			lock(messageQueue.SyncRoot) {
				messageQueue.Enqueue(msg);
			}
			waitEvent.Set();//Xbhx~̏ꍇ邽ߋN
		}

		/// <summary>
		/// bZ[WM
		/// </summary>
		private void SendMessageThread() {
			Message msg = null;
			while(true) {
				if(messageQueue.Count > 0) {
					//L[烁bZ[W擾
					lock(messageQueue.SyncRoot) {
						msg = (Message)messageQueue.Dequeue();
					}

					//bZ[WM
					networkStream.Write(msg.Data, 0, msg.Length);
				
					//MO
					model.Log.Write(string.Format("Send {0} ID={1} to {2}:{3}", msg.ToString(),
						msg.MessageIDToGuid.ToString(), servent.Address.ToString(), servent.Port));
				} else {
					//L[̏ꍇ̓Xbhx~
					waitEvent.WaitOne();
				}
			}
		}

		/// <summary>
		/// bZ[WM
		/// </summary>
		private void ReceiveMessageThread() {
			string logMessageName = "";

			try {
				//bZ[WM[v
				while(true) {
					//wb_[ǂݍ
					Read(networkStream, message.Data, 0, message.Length);

					//bZ[W̏
					if(message.Type == (byte)MessageType.Ping) {
						ReceivePingMessage();					//pingbZ[WM
						logMessageName = "Ping";
					} else if(message.Type == (byte)MessageType.Pong) {
						ReceivePongMessage();					//pongbZ[WM
						logMessageName = "Pong";
					} else if(message.Type == (byte)MessageType.Query) {
						ReceiveQueryMessage();					//querybZ[WM
						logMessageName = "Query";
					} else if(message.Type == (byte)MessageType.QueryChat) {
						ReceiveQueryChatMessage();				//queryChatbZ[WM
						logMessageName = "QueryChat";
					} else if(message.Type == (byte)MessageType.QueryChatHit) {
						ReceiveQueryChatHitMessage();			//queryChatHitbZ[WM
						logMessageName = "QueryChatHit";
					} else {
						logMessageName = "Error";
					}

					//MO
					model.Log.Write(string.Format("Receive {0} ID={1} from {2}:{3}", logMessageName,
						message.MessageIDToGuid.ToString(), servent.Address.ToString(), servent.Port));
				}
			} catch(SocketException e) {
				//G[
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} catch(NotBlockException e) {
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} catch(IOException e) {//AvP[VIɔAʂ̃XbhCloseƂɔ
				Console.WriteLine(e);
				Console.WriteLine(e.StackTrace);
			} finally {
				networkStream.Close();
				connection.Close();
			
				//ʐMÎ߁Ag폜R}h𔭍s
				commandController.PutCommand(new RemoveP2PConnection(this));
			}
		}

		/// <summary>
		/// pingM
		/// pingM̏ꍇ̓wb_[pingbZ[ŴߑɎMR}h𔭍s
		/// </summary>
		private void ReceivePingMessage() {
			PingMessage ping = new PingMessage();
			message.Data.CopyTo(ping.Data, 0);//message̓oϐ̂ߕKRs[ŒlnƁBQƂnƔj]B

			//pingMR}hs
			commandController.PutCommand(new ReceivePingCommand(this, ping));
		}

		/// <summary>
		/// pongM
		/// </summary>
		private void ReceivePongMessage() {
			PongMessage pong = new PongMessage();
			message.Data.CopyTo(pong.Data, 0);//message̓oϐ̂ߕKRs[ŒlnƁBQƂnƔj]B

			//yC[hM
			Read(networkStream, pong.Data, Message.headerSize, pong.PayloadSize);

			//pongMR}hs
			commandController.PutCommand(new ReceivePongCommand(this, pong));
		}

		/// <summary>
		/// QueryM
		/// </summary>
		private void ReceiveQueryMessage() {
			QueryMessage query = new QueryMessage(Message.headerSize + message.PayloadSize);
			message.Data.CopyTo(query.Data, 0);//message̓oϐ̂ߕKRs[ŒlnƁBQƂnƔj]B

			//yC[hM
			Read(networkStream, query.Data, Message.headerSize, query.PayloadSize);

			//queryMR}hs
			commandController.PutCommand(new ReceiveQueryCommand(this, query));
		}

		private void ReceiveQueryHitMessage() {
		}

		/// <summary>
		/// QueryChatM
		/// </summary>
		private void ReceiveQueryChatMessage() {
			QueryChatMessage queryChat = new QueryChatMessage(Message.headerSize + message.PayloadSize);
			message.Data.CopyTo(queryChat.Data, 0);//message̓oϐ̂ߕKRs[ŒlnƁBQƂnƔj]B

			//yC[hM
			Read(networkStream, queryChat.Data, Message.headerSize, queryChat.PayloadSize);

			//queryChatMR}hs
			commandController.PutCommand(new ReceiveQueryChatCommand(this, queryChat));
		}

		/// <summary>
		/// QueryChatHitM
		/// </summary>
		private void ReceiveQueryChatHitMessage() {
			QueryChatHitMessage queryChatHit = new QueryChatHitMessage(Message.headerSize + message.PayloadSize);
			message.Data.CopyTo(queryChatHit.Data, 0);//message̓oϐ̂ߕKRs[ŒlnƁBQƂnƔj]B

			//yC[hM
			Read(networkStream, queryChatHit.Data, Message.headerSize, queryChatHit.PayloadSize);

			//queryChatHitMR}hs
			commandController.PutCommand(new ReceiveQueryChatHitCommand(this, queryChatHit));
		}

		private void ReceivePushMessage() {
		}

		/// <summary>
		/// w肵f[^̃TCYKf[^ǂݏo\bh
		/// </summary>
		/// <param name="ns">ǂݏoɎglbg[NXg[</param>
		/// <param name="data">ǂݏõf[^</param>
		/// <param name="offset">ItZbg</param>
		/// <param name="size">f[^̃TCY</param>
		public void Read(NetworkStream ns, byte[] data, int offset, int size) {
			int count = 0;

			while(count < size) {
				int readSize = ns.Read(data, count + offset, size - count);
				count += readSize;
				if(readSize == 0) {
					//ubLOȂ̂ɂ炸AreadSize==0ŃX[ĂIB
					//{ubLȌꍇAreadSize==0΃X[Ȃ̂Aꕔ̏n
					//Ƃ̒ʐMŁÂ悤ȌۂBperlsocketW[B
					throw new NotBlockException("Read̃ubLOs܂B");
				}
			}
		}

		/// <summary>
		/// RlNVI\bh
		/// </summary>
		public void Close() {
			networkStream.Close();
			connection.Close();
			sendMessageThread.Abort();
			receiveMessageThread.Abort();
		}
	}

	/// <summary>
	/// bZ[WĂȂꍇɂłO
	/// </summary>
	public class NotBlockException : ApplicationException {
		public NotBlockException() {
		}
		public NotBlockException(string message) : base(message) {
		}
		public NotBlockException(string message, Exception inner) : base(message, inner) {
		}
	}

	/// <summary>
	/// RlNV[h
	/// </summary>
	public enum ConnectionType {
		None,
		P2P,
		Chat,
	}

}
