/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ZigumoForm.cs,v 1.28 2003/05/21 17:57:46 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Net;
using System.Threading;
using System.Windows.Forms;

using Zigumo.CommandObject;
using Zigumo.DialogObject;
using Zigumo.Model;
using Zigumo.View;

using System.Text;
using Zigumo.MessageObject;


namespace Zigumo
{
	/// <summary>
	/// ZigumoForm ̊Tv̐łB
	/// </summary>
	public class ZigumoForm : System.Windows.Forms.Form {
		/// <summary>
		/// fւ̎Q
		/// </summary>
		private ZigumoModel model;
		/// <summary>
		/// RlNV}l[Wւ̎Q
		/// </summary>
		private ConnectionManager connectionManager;
		/// <summary>
		/// R}hRg[ւ̎Q
		/// </summary>
		private CommandController commandController;

		/// <summary>
		/// ݕ\ĂT[ogXgi[ĂLbV
		/// </summary>
		private LRUCache printedServentList = new LRUCache(256);

		//EChERg[ptB[h
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.MenuItem connectionSetupMenu;
		private System.Windows.Forms.MenuItem connectZigumonetMenu;
		private System.Windows.Forms.TabControl categoryTabView;
		private System.Windows.Forms.TabPage categoryTab;
		private System.Windows.Forms.TabPage preferenceTab;
		private System.Windows.Forms.TabControl TabView;
		private System.Windows.Forms.TabPage chatTab;
		private System.Windows.Forms.MenuItem handShakeMenu;
		private System.Windows.Forms.MenuItem testMenu;
		private System.Windows.Forms.MenuItem pingMenu;
		private System.Windows.Forms.MenuItem queryMenu;
		private System.Windows.Forms.MenuItem forceTestMenu;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel threadControlPanel;
		private System.Windows.Forms.TabPage bbsTab;
		private System.Windows.Forms.TabPage logTab;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox systemLogTextBox;
		private System.Windows.Forms.TabPage systemTab;
		private System.Windows.Forms.TabPage serventTab;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem updateCategoryMenu;
		private System.Windows.Forms.ImageList categoryImageList;
		private System.Windows.Forms.Timer timer;
		private System.Windows.Forms.TabControl bbsThreadTabView;
		private System.Windows.Forms.TreeView bbsCategoryTreeView;
		private System.Windows.Forms.TabControl bbsCategoryTabView;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Label bbsThreadTitleLabel;
		private System.Windows.Forms.ToolBar bbsThreadToolBar;
		private System.Windows.Forms.ToolBarButton writeBbsResButton;
		private System.Windows.Forms.ToolBarButton closeTabButton;
		private System.Windows.Forms.ToolBarButton updateBbsThreadButton;
		private System.Windows.Forms.ImageList bbsThreadToolBarImageList;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.ColumnHeader serventIDHeader;
		private System.Windows.Forms.ColumnHeader connectionStatusHeader;
		private System.Windows.Forms.ColumnHeader lastConnectHeader;
		private System.Windows.Forms.ColumnHeader categoryHeader;
		private System.Windows.Forms.ListView serventListView;
		private System.Windows.Forms.ListView chatListView;
		private System.Windows.Forms.ColumnHeader chatServentIDHeader;
		private System.Windows.Forms.ColumnHeader chatNameHeader;
		private System.Windows.Forms.ColumnHeader chatNumberHeader;
		private System.Windows.Forms.ColumnHeader chatMaxNumberHeader;
		private System.Windows.Forms.PictureBox zigumoIcon;
		private System.Windows.Forms.Label zigumoVersionLabel;
		private System.Windows.Forms.LinkLabel zigumoOrgLinkLabel;
		private System.Windows.Forms.Panel chatServerLeftPanel;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem preferenceMenuItem;
		private System.Windows.Forms.MenuItem chatMenuItem;
		private System.Windows.Forms.MenuItem queryChatMenu;
		private System.Windows.Forms.ImageList bbsCategoryTabImageList;
		private System.Windows.Forms.ContextMenu categoryTreeMenu;
		private System.Windows.Forms.MenuItem openZigumoTabMenu;
		private System.Windows.Forms.MenuItem open2chTabMenu;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem zigumoServerMenu;
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// ݑIĂJeSm[h\vpeB
		/// </summary>
		public TreeNode SelectedNode {
			get {
				return this.bbsCategoryTreeView.SelectedNode;
			}
		}

		/// <summary>
		/// ݑIĂXbhXg\vpeB
		/// </summary>
		public BbsCategoryTabPage SelectedBbsCategoryTabPage {
			get {
				return (BbsCategoryTabPage)this.bbsCategoryTabView.SelectedTab;
			}
		}

		/// <summary>
		/// ݑIĂBbsThreadTabPage\
		/// </summary>
		public BbsThreadTabPage SelectedBbsThreadTapPage {
			get {
				return (BbsThreadTabPage)this.bbsThreadTabView.SelectedTab;
			}
		}

		/// <summary>
		/// Xbh\^ur[̃vpeB
		/// </summary>
		public TabControl BbsThreadTabView {
			get {
				return bbsThreadTabView;
			}
		}

		/// <summary>
		/// Xbh^Cgx̃vpeB
		/// </summary>
		public string BbsThreadTitleLabel {
			get {
				return bbsThreadTitleLabel.Text;
			}
			set {
				bbsThreadTitleLabel.Text = value;
			}
		}

		public ZigumoForm() {
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// RXgN^
			//

			//eRANX̎擾
			model = ZigumoModel.Model;
			model.Form = this;
			model.ApplicationName = Path.GetFileName(Application.ExecutablePath);
			model.Log.Write("zigumo StartUp");

			connectionManager = ConnectionManager.Manager;
			connectionManager.Form = this;
			commandController = CommandController.Controller;
			commandController.Form = this;

			//fobOmFp̂߃Xbh𖽖
			Thread.CurrentThread.Name = "zigumo Main Thread";

			//zigumoo[W\L̐ݒ
			zigumoVersionLabel.Text += model.ZigumoVersion;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ZigumoForm));
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.connectionSetupMenu = new System.Windows.Forms.MenuItem();
			this.pingMenu = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.queryMenu = new System.Windows.Forms.MenuItem();
			this.queryChatMenu = new System.Windows.Forms.MenuItem();
			this.testMenu = new System.Windows.Forms.MenuItem();
			this.forceTestMenu = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.connectZigumonetMenu = new System.Windows.Forms.MenuItem();
			this.handShakeMenu = new System.Windows.Forms.MenuItem();
			this.updateCategoryMenu = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.chatMenuItem = new System.Windows.Forms.MenuItem();
			this.preferenceMenuItem = new System.Windows.Forms.MenuItem();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.categoryTabView = new System.Windows.Forms.TabControl();
			this.categoryTab = new System.Windows.Forms.TabPage();
			this.bbsCategoryTreeView = new System.Windows.Forms.TreeView();
			this.categoryTreeMenu = new System.Windows.Forms.ContextMenu();
			this.openZigumoTabMenu = new System.Windows.Forms.MenuItem();
			this.open2chTabMenu = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.zigumoServerMenu = new System.Windows.Forms.MenuItem();
			this.categoryImageList = new System.Windows.Forms.ImageList(this.components);
			this.preferenceTab = new System.Windows.Forms.TabPage();
			this.TabView = new System.Windows.Forms.TabControl();
			this.bbsTab = new System.Windows.Forms.TabPage();
			this.bbsThreadTabView = new System.Windows.Forms.TabControl();
			this.bbsCategoryTabImageList = new System.Windows.Forms.ImageList(this.components);
			this.threadControlPanel = new System.Windows.Forms.Panel();
			this.bbsThreadToolBar = new System.Windows.Forms.ToolBar();
			this.writeBbsResButton = new System.Windows.Forms.ToolBarButton();
			this.updateBbsThreadButton = new System.Windows.Forms.ToolBarButton();
			this.closeTabButton = new System.Windows.Forms.ToolBarButton();
			this.bbsThreadToolBarImageList = new System.Windows.Forms.ImageList(this.components);
			this.bbsThreadTitleLabel = new System.Windows.Forms.Label();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.bbsCategoryTabView = new System.Windows.Forms.TabControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.chatTab = new System.Windows.Forms.TabPage();
			this.chatListView = new System.Windows.Forms.ListView();
			this.chatServentIDHeader = new System.Windows.Forms.ColumnHeader();
			this.chatNameHeader = new System.Windows.Forms.ColumnHeader();
			this.chatNumberHeader = new System.Windows.Forms.ColumnHeader();
			this.chatMaxNumberHeader = new System.Windows.Forms.ColumnHeader();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.chatServerLeftPanel = new System.Windows.Forms.Panel();
			this.panel4 = new System.Windows.Forms.Panel();
			this.serventTab = new System.Windows.Forms.TabPage();
			this.serventListView = new System.Windows.Forms.ListView();
			this.serventIDHeader = new System.Windows.Forms.ColumnHeader();
			this.connectionStatusHeader = new System.Windows.Forms.ColumnHeader();
			this.lastConnectHeader = new System.Windows.Forms.ColumnHeader();
			this.categoryHeader = new System.Windows.Forms.ColumnHeader();
			this.panel2 = new System.Windows.Forms.Panel();
			this.logTab = new System.Windows.Forms.TabPage();
			this.systemLogTextBox = new System.Windows.Forms.TextBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.systemTab = new System.Windows.Forms.TabPage();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.panel3 = new System.Windows.Forms.Panel();
			this.zigumoOrgLinkLabel = new System.Windows.Forms.LinkLabel();
			this.zigumoVersionLabel = new System.Windows.Forms.Label();
			this.zigumoIcon = new System.Windows.Forms.PictureBox();
			this.timer = new System.Windows.Forms.Timer(this.components);
			this.categoryTabView.SuspendLayout();
			this.categoryTab.SuspendLayout();
			this.TabView.SuspendLayout();
			this.bbsTab.SuspendLayout();
			this.threadControlPanel.SuspendLayout();
			this.chatTab.SuspendLayout();
			this.serventTab.SuspendLayout();
			this.logTab.SuspendLayout();
			this.systemTab.SuspendLayout();
			this.panel3.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItem1,
																					 this.menuItem2,
																					 this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.connectionSetupMenu,
																					  this.pingMenu,
																					  this.menuItem4,
																					  this.queryMenu,
																					  this.queryChatMenu,
																					  this.testMenu,
																					  this.forceTestMenu});
			this.menuItem1.Text = "eXgj[";
			// 
			// connectionSetupMenu
			// 
			this.connectionSetupMenu.Index = 0;
			this.connectionSetupMenu.Text = "ڑݒ";
			this.connectionSetupMenu.Click += new System.EventHandler(this.connectionSetupMenu_Click);
			// 
			// pingMenu
			// 
			this.pingMenu.Index = 1;
			this.pingMenu.Text = "ping";
			this.pingMenu.Click += new System.EventHandler(this.pingMenu_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "pong";
			// 
			// queryMenu
			// 
			this.queryMenu.Index = 3;
			this.queryMenu.Text = "query";
			this.queryMenu.Click += new System.EventHandler(this.queryMenu_Click);
			// 
			// queryChatMenu
			// 
			this.queryChatMenu.Index = 4;
			this.queryChatMenu.Text = "queryChat";
			this.queryChatMenu.Click += new System.EventHandler(this.queryChatMenu_Click);
			// 
			// testMenu
			// 
			this.testMenu.Index = 5;
			this.testMenu.Text = "eXgs";
			this.testMenu.Click += new System.EventHandler(this.testMenu_Click);
			// 
			// forceTestMenu
			// 
			this.forceTestMenu.Index = 6;
			this.forceTestMenu.Text = "׎";
			this.forceTestMenu.Click += new System.EventHandler(this.forceTestMenu_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.connectZigumonetMenu,
																					  this.handShakeMenu,
																					  this.updateCategoryMenu});
			this.menuItem2.Text = "ʐM";
			// 
			// connectZigumonetMenu
			// 
			this.connectZigumonetMenu.Index = 0;
			this.connectZigumonetMenu.Text = "Gg[|Cgڑ";
			this.connectZigumonetMenu.Click += new System.EventHandler(this.connectZigumonetMenu_Click);
			// 
			// handShakeMenu
			// 
			this.handShakeMenu.Index = 1;
			this.handShakeMenu.Text = "nhVFCN";
			this.handShakeMenu.Click += new System.EventHandler(this.handShakeMenu_Click);
			// 
			// updateCategoryMenu
			// 
			this.updateCategoryMenu.Index = 2;
			this.updateCategoryMenu.Text = "JeSj[XV";
			this.updateCategoryMenu.Click += new System.EventHandler(this.updateCategoryMenu_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.chatMenuItem,
																					  this.preferenceMenuItem});
			this.menuItem3.Text = "c[";
			// 
			// chatMenuItem
			// 
			this.chatMenuItem.Index = 0;
			this.chatMenuItem.Text = "`bgݒ...";
			this.chatMenuItem.Click += new System.EventHandler(this.chatMenuItem_Click);
			// 
			// preferenceMenuItem
			// 
			this.preferenceMenuItem.Index = 1;
			this.preferenceMenuItem.Text = "ݒ...";
			this.preferenceMenuItem.Click += new System.EventHandler(this.preferenceMenuItem_Click);
			// 
			// toolBar
			// 
			this.toolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.toolBarButton1});
			this.toolBar.DropDownArrows = true;
			this.toolBar.Location = new System.Drawing.Point(0, 0);
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(832, 28);
			this.toolBar.TabIndex = 0;
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 587);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(832, 22);
			this.statusBar.TabIndex = 1;
			this.statusBar.Text = "zigumo Redy !!";
			// 
			// categoryTabView
			// 
			this.categoryTabView.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
			this.categoryTabView.Controls.Add(this.categoryTab);
			this.categoryTabView.Controls.Add(this.preferenceTab);
			this.categoryTabView.Dock = System.Windows.Forms.DockStyle.Left;
			this.categoryTabView.HotTrack = true;
			this.categoryTabView.Location = new System.Drawing.Point(0, 0);
			this.categoryTabView.Name = "categoryTabView";
			this.categoryTabView.SelectedIndex = 0;
			this.categoryTabView.Size = new System.Drawing.Size(184, 534);
			this.categoryTabView.TabIndex = 9;
			// 
			// categoryTab
			// 
			this.categoryTab.Controls.Add(this.bbsCategoryTreeView);
			this.categoryTab.Location = new System.Drawing.Point(4, 24);
			this.categoryTab.Name = "categoryTab";
			this.categoryTab.Size = new System.Drawing.Size(176, 506);
			this.categoryTab.TabIndex = 0;
			this.categoryTab.Text = "JeS";
			// 
			// bbsCategoryTreeView
			// 
			this.bbsCategoryTreeView.ContextMenu = this.categoryTreeMenu;
			this.bbsCategoryTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.bbsCategoryTreeView.HideSelection = false;
			this.bbsCategoryTreeView.HotTracking = true;
			this.bbsCategoryTreeView.ImageList = this.categoryImageList;
			this.bbsCategoryTreeView.Indent = 19;
			this.bbsCategoryTreeView.Location = new System.Drawing.Point(0, 0);
			this.bbsCategoryTreeView.Name = "bbsCategoryTreeView";
			this.bbsCategoryTreeView.Size = new System.Drawing.Size(176, 506);
			this.bbsCategoryTreeView.TabIndex = 2;
			this.bbsCategoryTreeView.MouseDown += new System.Windows.Forms.MouseEventHandler(this.bbsCategoryTreeView_MouseDown);
			this.bbsCategoryTreeView.MouseUp += new System.Windows.Forms.MouseEventHandler(this.bbsCategoryTreeView_MouseUp);
			// 
			// categoryTreeMenu
			// 
			this.categoryTreeMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.openZigumoTabMenu,
																							 this.open2chTabMenu,
																							 this.menuItem5,
																							 this.zigumoServerMenu});
			this.categoryTreeMenu.RightToLeft = System.Windows.Forms.RightToLeft.No;
			// 
			// openZigumoTabMenu
			// 
			this.openZigumoTabMenu.Index = 0;
			this.openZigumoTabMenu.Text = "zigumoJ";
			this.openZigumoTabMenu.Click += new System.EventHandler(this.openZigumoTabMenu_Click);
			// 
			// open2chTabMenu
			// 
			this.open2chTabMenu.Index = 1;
			this.open2chTabMenu.Text = "QJ";
			this.open2chTabMenu.Click += new System.EventHandler(this.open2chTabMenu_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 2;
			this.menuItem5.Text = "-";
			// 
			// zigumoServerMenu
			// 
			this.zigumoServerMenu.Index = 3;
			this.zigumoServerMenu.Text = "zigumoT[oݒ";
			this.zigumoServerMenu.Click += new System.EventHandler(this.zigumoServerMenu_Click);
			// 
			// categoryImageList
			// 
			this.categoryImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth24Bit;
			this.categoryImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.categoryImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("categoryImageList.ImageStream")));
			this.categoryImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// preferenceTab
			// 
			this.preferenceTab.Location = new System.Drawing.Point(4, 24);
			this.preferenceTab.Name = "preferenceTab";
			this.preferenceTab.Size = new System.Drawing.Size(176, 506);
			this.preferenceTab.TabIndex = 2;
			this.preferenceTab.Text = "Cɓ";
			// 
			// TabView
			// 
			this.TabView.Controls.Add(this.bbsTab);
			this.TabView.Controls.Add(this.chatTab);
			this.TabView.Controls.Add(this.serventTab);
			this.TabView.Controls.Add(this.logTab);
			this.TabView.Controls.Add(this.systemTab);
			this.TabView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.TabView.HotTrack = true;
			this.TabView.Location = new System.Drawing.Point(0, 28);
			this.TabView.Name = "TabView";
			this.TabView.SelectedIndex = 0;
			this.TabView.Size = new System.Drawing.Size(832, 559);
			this.TabView.TabIndex = 4;
			this.TabView.SelectedIndexChanged += new System.EventHandler(this.TabView_SelectedIndexChanged);
			// 
			// bbsTab
			// 
			this.bbsTab.Controls.Add(this.bbsThreadTabView);
			this.bbsTab.Controls.Add(this.threadControlPanel);
			this.bbsTab.Controls.Add(this.splitter2);
			this.bbsTab.Controls.Add(this.bbsCategoryTabView);
			this.bbsTab.Controls.Add(this.splitter1);
			this.bbsTab.Controls.Add(this.categoryTabView);
			this.bbsTab.Location = new System.Drawing.Point(4, 21);
			this.bbsTab.Name = "bbsTab";
			this.bbsTab.Size = new System.Drawing.Size(824, 534);
			this.bbsTab.TabIndex = 0;
			this.bbsTab.Text = "P2P BBS";
			// 
			// bbsThreadTabView
			// 
			this.bbsThreadTabView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.bbsThreadTabView.HotTrack = true;
			this.bbsThreadTabView.ImageList = this.bbsCategoryTabImageList;
			this.bbsThreadTabView.ItemSize = new System.Drawing.Size(128, 20);
			this.bbsThreadTabView.Location = new System.Drawing.Point(187, 259);
			this.bbsThreadTabView.Multiline = true;
			this.bbsThreadTabView.Name = "bbsThreadTabView";
			this.bbsThreadTabView.SelectedIndex = 0;
			this.bbsThreadTabView.Size = new System.Drawing.Size(637, 275);
			this.bbsThreadTabView.SizeMode = System.Windows.Forms.TabSizeMode.Fixed;
			this.bbsThreadTabView.TabIndex = 8;
			this.bbsThreadTabView.SelectedIndexChanged += new System.EventHandler(this.bbsThreadTabView_SelectedIndexChanged);
			// 
			// bbsCategoryTabImageList
			// 
			this.bbsCategoryTabImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.bbsCategoryTabImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("bbsCategoryTabImageList.ImageStream")));
			this.bbsCategoryTabImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// threadControlPanel
			// 
			this.threadControlPanel.Controls.Add(this.bbsThreadToolBar);
			this.threadControlPanel.Controls.Add(this.bbsThreadTitleLabel);
			this.threadControlPanel.Dock = System.Windows.Forms.DockStyle.Top;
			this.threadControlPanel.Location = new System.Drawing.Point(187, 235);
			this.threadControlPanel.Name = "threadControlPanel";
			this.threadControlPanel.Size = new System.Drawing.Size(637, 24);
			this.threadControlPanel.TabIndex = 7;
			// 
			// bbsThreadToolBar
			// 
			this.bbsThreadToolBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.bbsThreadToolBar.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.bbsThreadToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																								this.writeBbsResButton,
																								this.updateBbsThreadButton,
																								this.closeTabButton});
			this.bbsThreadToolBar.Dock = System.Windows.Forms.DockStyle.None;
			this.bbsThreadToolBar.DropDownArrows = true;
			this.bbsThreadToolBar.ImageList = this.bbsThreadToolBarImageList;
			this.bbsThreadToolBar.Location = new System.Drawing.Point(565, -2);
			this.bbsThreadToolBar.Name = "bbsThreadToolBar";
			this.bbsThreadToolBar.ShowToolTips = true;
			this.bbsThreadToolBar.Size = new System.Drawing.Size(72, 28);
			this.bbsThreadToolBar.TabIndex = 1;
			this.bbsThreadToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.bbsThreadToolBar_ButtonClick);
			// 
			// updateBbsThreadButton
			// 
			this.updateBbsThreadButton.ImageIndex = 0;
			// 
			// closeTabButton
			// 
			this.closeTabButton.ImageIndex = 1;
			// 
			// bbsThreadToolBarImageList
			// 
			this.bbsThreadToolBarImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.bbsThreadToolBarImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.bbsThreadToolBarImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("bbsThreadToolBarImageList.ImageStream")));
			this.bbsThreadToolBarImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// bbsThreadTitleLabel
			// 
			this.bbsThreadTitleLabel.AutoSize = true;
			this.bbsThreadTitleLabel.Location = new System.Drawing.Point(6, 4);
			this.bbsThreadTitleLabel.Name = "bbsThreadTitleLabel";
			this.bbsThreadTitleLabel.Size = new System.Drawing.Size(0, 15);
			this.bbsThreadTitleLabel.TabIndex = 0;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(187, 232);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(637, 3);
			this.splitter2.TabIndex = 6;
			this.splitter2.TabStop = false;
			// 
			// bbsCategoryTabView
			// 
			this.bbsCategoryTabView.Appearance = System.Windows.Forms.TabAppearance.FlatButtons;
			this.bbsCategoryTabView.Dock = System.Windows.Forms.DockStyle.Top;
			this.bbsCategoryTabView.HotTrack = true;
			this.bbsCategoryTabView.ImageList = this.bbsCategoryTabImageList;
			this.bbsCategoryTabView.Location = new System.Drawing.Point(187, 0);
			this.bbsCategoryTabView.Name = "bbsCategoryTabView";
			this.bbsCategoryTabView.SelectedIndex = 0;
			this.bbsCategoryTabView.Size = new System.Drawing.Size(637, 232);
			this.bbsCategoryTabView.TabIndex = 5;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(184, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 534);
			this.splitter1.TabIndex = 4;
			this.splitter1.TabStop = false;
			// 
			// chatTab
			// 
			this.chatTab.Controls.Add(this.chatListView);
			this.chatTab.Controls.Add(this.splitter3);
			this.chatTab.Controls.Add(this.chatServerLeftPanel);
			this.chatTab.Controls.Add(this.panel4);
			this.chatTab.Location = new System.Drawing.Point(4, 21);
			this.chatTab.Name = "chatTab";
			this.chatTab.Size = new System.Drawing.Size(824, 534);
			this.chatTab.TabIndex = 2;
			this.chatTab.Text = "`bgT[o";
			// 
			// chatListView
			// 
			this.chatListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.chatServentIDHeader,
																						   this.chatNameHeader,
																						   this.chatNumberHeader,
																						   this.chatMaxNumberHeader});
			this.chatListView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.chatListView.Location = new System.Drawing.Point(187, 32);
			this.chatListView.Name = "chatListView";
			this.chatListView.Size = new System.Drawing.Size(637, 502);
			this.chatListView.TabIndex = 4;
			this.chatListView.View = System.Windows.Forms.View.Details;
			// 
			// chatServentIDHeader
			// 
			this.chatServentIDHeader.Text = "T[ogID";
			this.chatServentIDHeader.Width = 160;
			// 
			// chatNameHeader
			// 
			this.chatNameHeader.Text = "[";
			this.chatNameHeader.Width = 300;
			// 
			// chatNumberHeader
			// 
			this.chatNumberHeader.Text = "l";
			this.chatNumberHeader.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.chatNumberHeader.Width = 48;
			// 
			// chatMaxNumberHeader
			// 
			this.chatMaxNumberHeader.Text = "ő";
			this.chatMaxNumberHeader.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.chatMaxNumberHeader.Width = 48;
			// 
			// splitter3
			// 
			this.splitter3.Location = new System.Drawing.Point(184, 32);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(3, 502);
			this.splitter3.TabIndex = 3;
			this.splitter3.TabStop = false;
			// 
			// chatServerLeftPanel
			// 
			this.chatServerLeftPanel.Dock = System.Windows.Forms.DockStyle.Left;
			this.chatServerLeftPanel.Location = new System.Drawing.Point(0, 32);
			this.chatServerLeftPanel.Name = "chatServerLeftPanel";
			this.chatServerLeftPanel.Size = new System.Drawing.Size(184, 502);
			this.chatServerLeftPanel.TabIndex = 2;
			// 
			// panel4
			// 
			this.panel4.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel4.Location = new System.Drawing.Point(0, 0);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(824, 32);
			this.panel4.TabIndex = 0;
			// 
			// serventTab
			// 
			this.serventTab.Controls.Add(this.serventListView);
			this.serventTab.Controls.Add(this.panel2);
			this.serventTab.Location = new System.Drawing.Point(4, 21);
			this.serventTab.Name = "serventTab";
			this.serventTab.Size = new System.Drawing.Size(824, 534);
			this.serventTab.TabIndex = 5;
			this.serventTab.Text = "T[og";
			// 
			// serventListView
			// 
			this.serventListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							  this.serventIDHeader,
																							  this.connectionStatusHeader,
																							  this.lastConnectHeader,
																							  this.categoryHeader});
			this.serventListView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.serventListView.FullRowSelect = true;
			this.serventListView.Location = new System.Drawing.Point(0, 32);
			this.serventListView.Name = "serventListView";
			this.serventListView.Size = new System.Drawing.Size(824, 502);
			this.serventListView.TabIndex = 1;
			this.serventListView.View = System.Windows.Forms.View.Details;
			// 
			// serventIDHeader
			// 
			this.serventIDHeader.Text = "T[ogID";
			this.serventIDHeader.Width = 160;
			// 
			// connectionStatusHeader
			// 
			this.connectionStatusHeader.Text = "ڑ";
			this.connectionStatusHeader.Width = 80;
			// 
			// lastConnectHeader
			// 
			this.lastConnectHeader.Text = "ŏImF";
			this.lastConnectHeader.Width = 128;
			// 
			// categoryHeader
			// 
			this.categoryHeader.Text = "JeS";
			this.categoryHeader.Width = 400;
			// 
			// panel2
			// 
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(824, 32);
			this.panel2.TabIndex = 0;
			// 
			// logTab
			// 
			this.logTab.Controls.Add(this.systemLogTextBox);
			this.logTab.Controls.Add(this.panel1);
			this.logTab.Location = new System.Drawing.Point(4, 21);
			this.logTab.Name = "logTab";
			this.logTab.Size = new System.Drawing.Size(824, 534);
			this.logTab.TabIndex = 3;
			this.logTab.Text = "O";
			// 
			// systemLogTextBox
			// 
			this.systemLogTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
			this.systemLogTextBox.Location = new System.Drawing.Point(0, 32);
			this.systemLogTextBox.Multiline = true;
			this.systemLogTextBox.Name = "systemLogTextBox";
			this.systemLogTextBox.Size = new System.Drawing.Size(824, 502);
			this.systemLogTextBox.TabIndex = 3;
			this.systemLogTextBox.Text = "";
			// 
			// panel1
			// 
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(824, 32);
			this.panel1.TabIndex = 2;
			// 
			// systemTab
			// 
			this.systemTab.Controls.Add(this.textBox1);
			this.systemTab.Controls.Add(this.panel3);
			this.systemTab.Location = new System.Drawing.Point(4, 21);
			this.systemTab.Name = "systemTab";
			this.systemTab.Size = new System.Drawing.Size(824, 534);
			this.systemTab.TabIndex = 4;
			this.systemTab.Text = "VXe";
			// 
			// textBox1
			// 
			this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Location = new System.Drawing.Point(0, 88);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ReadOnly = true;
			this.textBox1.Size = new System.Drawing.Size(824, 446);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.zigumoOrgLinkLabel);
			this.panel3.Controls.Add(this.zigumoVersionLabel);
			this.panel3.Controls.Add(this.zigumoIcon);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel3.Location = new System.Drawing.Point(0, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(824, 88);
			this.panel3.TabIndex = 0;
			// 
			// zigumoOrgLinkLabel
			// 
			this.zigumoOrgLinkLabel.Location = new System.Drawing.Point(96, 32);
			this.zigumoOrgLinkLabel.Name = "zigumoOrgLinkLabel";
			this.zigumoOrgLinkLabel.Size = new System.Drawing.Size(200, 16);
			this.zigumoOrgLinkLabel.TabIndex = 2;
			this.zigumoOrgLinkLabel.TabStop = true;
			this.zigumoOrgLinkLabel.Text = "http://www8.tok2.com/home2/peko/";
			this.zigumoOrgLinkLabel.Click += new System.EventHandler(this.zigumoOrgLinkLabel_Click);
			// 
			// zigumoVersionLabel
			// 
			this.zigumoVersionLabel.AutoSize = true;
			this.zigumoVersionLabel.Location = new System.Drawing.Point(96, 16);
			this.zigumoVersionLabel.Name = "zigumoVersionLabel";
			this.zigumoVersionLabel.Size = new System.Drawing.Size(104, 15);
			this.zigumoVersionLabel.TabIndex = 1;
			this.zigumoVersionLabel.Text = "Zigumo  Version ";
			// 
			// zigumoIcon
			// 
			this.zigumoIcon.Image = ((System.Drawing.Image)(resources.GetObject("zigumoIcon.Image")));
			this.zigumoIcon.Location = new System.Drawing.Point(24, 8);
			this.zigumoIcon.Name = "zigumoIcon";
			this.zigumoIcon.Size = new System.Drawing.Size(48, 48);
			this.zigumoIcon.TabIndex = 0;
			this.zigumoIcon.TabStop = false;
			// 
			// timer
			// 
			this.timer.Interval = 1000;
			this.timer.Tick += new System.EventHandler(this.timer_Tick);
			// 
			// ZigumoForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(832, 609);
			this.Controls.Add(this.TabView);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.toolBar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "ZigumoForm";
			this.Text = "Zigumo";
			this.Load += new System.EventHandler(this.ZigumoForm_Load);
			this.Closed += new System.EventHandler(this.ZigumoForm_Closed);
			this.categoryTabView.ResumeLayout(false);
			this.categoryTab.ResumeLayout(false);
			this.TabView.ResumeLayout(false);
			this.bbsTab.ResumeLayout(false);
			this.threadControlPanel.ResumeLayout(false);
			this.chatTab.ResumeLayout(false);
			this.serventTab.ResumeLayout(false);
			this.logTab.ResumeLayout(false);
			this.systemTab.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		
		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new ZigumoForm());
		}

		/// <summary>
		/// tH[CX^XŁAAtH[\Oɍs\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ZigumoForm_Load(object sender, System.EventArgs e) {
			//EChETCYݒ
            if(model.Width > 0) this.Width = model.Width;
			if(model.Height > 0) this.Height = model.Height;
			if(model.SplitterWidth > 0) this.splitter1.SplitPosition = model.SplitterWidth;
			if(model.SplitterHeight > 0) this.splitter2.SplitPosition = model.SplitterHeight;

			//JeSc[̓ǂݍ
			if(File.Exists(model.BbsCategoryFileName)) {
				UpdateCategoryTreeView();
			}

			//XbhXg^uJ
			this.bbsCategoryTabView.TabPages.Add(new BbsCategoryTabPage(this, BbsType.Bbs2ch));
			this.bbsCategoryTabView.TabPages.Add(new BbsCategoryTabPage(this, BbsType.Zigumo));

			//Xbh\p^uJ
			BbsThreadTabPage bbsThreadTabPage = new BbsThreadTabPage();
			this.bbsThreadTabView.TabPages.Add(bbsThreadTabPage);
		}

		/// <summary>
		/// JeSc[t@CǂݍݍXVB
		/// </summary>
		public void UpdateCategoryTreeView() {
			//݂̃c[NA
			this.bbsCategoryTreeView.Nodes.Clear();

			//JeSc[̓ǂݍ
			ArrayList expandNodes = model.LoadCategoryTree(this.bbsCategoryTreeView.Nodes);

			//I[vȃm[hJ
			foreach(TreeNode openNode in expandNodes) {
				openNode.Expand();
			}
		}

		/// <summary>
		/// JeSc[̊JԂۑ
		/// </summary>
		private void SaveCategoryTreeView() {
			//XML`ŃJeSc[ۑB
			model.SaveCategoryTree(this.bbsCategoryTreeView.Nodes);
		}

		/// <summary>
		/// Xe[^Xo[XV
		/// </summary>
		/// <param name="text">Xe[^Xo[ɕ\镶</param>
		public void SetStatusBar(string text) {
			statusBar.Text = text;
		}

		/// <summary>
		/// VXeOo͗peLXg{bNXXV\bh
		/// </summary>
		/// <param name="text">o͓e</param>
		private void UpdateSystemLogTextBox(string text) {
			this.systemLogTextBox.Text = text;
			this.systemLogTextBox.SelectionStart = this.systemLogTextBox.Text.Length;
			this.systemLogTextBox.ScrollToCaret();
		}

		/// <summary>
		/// T[og^ũT[ogꗗXV
		/// </summary>
		private void UpdateServentList() {
			ArrayList list = connectionManager.GetServentList();
			if(list != null) {
				foreach(Servent servent in list) {
					ListViewItem item = (ListViewItem)printedServentList.Get(servent);
					//ȊOŁ@@iڑ\ȃT[og@@ڑĂ܂ĂT[ogj@͕\
					if(!model.MyServent.Equals(servent) && (servent.ConnectionEnabledFlag || servent.P2PConnection != null)) {
						if(item == null) {//ɕ\ĂȂǂ`FbN
							//\ĂȂꍇ
							item = servent.GetListViewItem();
							serventListView.Items.Add(item);
						} else {
							//\Ăꍇ
							ListViewItem newItem = servent.GetListViewItem();
							item.Text = newItem.Text;
							for(int i = 0; i < item.SubItems.Count; i++) {
								item.SubItems[i] = newItem.SubItems[i];
							}
						}
						printedServentList.Put(servent, item);
					} else {
						//\Ă܂Ăꍇ
						if(item != null) {
							serventListView.Items.Remove(item);
						}
					}//end if
				}
			}//end if
		}

		/// <summary>
		/// JeSj[XV
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void updateCategoryMenu_Click(object sender, System.EventArgs e) {
			//JeSc[̍XV
			model.UpdateCategoryTree(this.bbsCategoryTreeView.Nodes);
		}

		/// <summary>
		/// c[m[h̃ReLXgj[L؂ւ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bbsCategoryTreeView_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			Point point = new Point(e.X, e.Y);
			TreeNode node = this.bbsCategoryTreeView.GetNodeAt(point);
			Rectangle rect = node.Bounds;
			rect.X -= 19; rect.Width += 19;//摜̕␳
			if(rect.Contains(point)) {
				//JeS擾
				BbsCategory category = (BbsCategory)node.Tag;
				if(e.Button == MouseButtons.Right) {
					Menu.MenuItemCollection items = this.categoryTreeMenu.MenuItems;
					if(category == null || this.TabView.SelectedTab == this.chatTab) {
						//ENbNۂɃJeSnullA`bg^u\ł΃j[͑Sfalseɂ
						foreach(MenuItem item in items) {
							item.Enabled = false;
						}
					} else {
						foreach(MenuItem item in items) {
							item.Enabled = true;
						}
					}//end if
				}//end if
			}//end if
		}
		
		/// <summary>
		/// c[m[hNbN
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bbsCategoryTreeView_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			Point point = new Point(e.X, e.Y);
			TreeNode node = this.bbsCategoryTreeView.GetNodeAt(point);
			Rectangle rect = node.Bounds;
			rect.X -= 19; rect.Width += 19;//摜̕␳
			if(rect.Contains(point)) {
				//JeS擾
				BbsCategory category = (BbsCategory)node.Tag;
				if(e.Button == MouseButtons.Left) {
					//XbhXgXV
					if(category != null) {
						//IĂ^uɉď؂ւ
						if(this.TabView.SelectedTab == this.bbsTab) {
							//BBS^uI𒆂̓XbhXg̍XVs
							category.TabPage = this.SelectedBbsCategoryTabPage;//\̃^uݒ
							category.UpdateCategory();//\eXV
						} else if(this.TabView.SelectedTab == this.chatTab) {
							//`bg^uI𒆂̓`bgT[oXg̍XVs
							//test
							Console.WriteLine("Update Chat Server List!!");
						}
					} else {
						//m[hJ
						node.Toggle();
					}
				} else {
					//ENbNꂽm[hIԂɐݒ
					this.bbsCategoryTreeView.SelectedNode = node;
				}
			}
		}

		/// <summary>
		/// uEU^u؂ւ
		/// uEU^u؂ւۂɌĂ΂
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bbsThreadTabView_SelectedIndexChanged(object sender, System.EventArgs e) {
			TabPage page = bbsThreadTabView.SelectedTab;
			this.bbsThreadTitleLabel.Text = page.Text;
		}


		/// <summary>
		/// ^ur[؂ւ
		/// C̃^u؂ւۂɌĂ΂
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void TabView_SelectedIndexChanged(object sender, System.EventArgs e) {
			TabPage page = this.TabView.SelectedTab;
			//XV\p^C}̐ݒ
			if(page == this.logTab) {
				this.UpdateSystemLogTextBox(model.Log.GetLog());
				this.timer.Start();//O\[hJn
			} else if(page == this.serventTab) {
				this.timer.Start();//T[ogꗗ\[hJn
			} else if(page == this.chatTab) {
				this.timer.Stop();//XV\~
				if(this.chatServerLeftPanel.Controls.Count == 0)//Rg[ݒ肳ĂȂ
					this.chatServerLeftPanel.Controls.Add(this.bbsCategoryTreeView);//JeSc[Zbg
			} else if(page == this.bbsTab) {
				this.timer.Stop();//XV\~
				if(this.categoryTab.Controls.Count == 0)//Rg[ݒ肳ĂȂ
					this.categoryTab.Controls.Add(this.bbsCategoryTreeView);//JeSc[Zbg
			} else {
				this.timer.Stop();//XV\~
			}
		}

		/// <summary>
		/// Xbh^ur[̃c[o[NbNꂽ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bbsThreadToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e) {
			if(e.Button == this.updateBbsThreadButton) {
				//\̃XbhtbV
				BbsThreadTabPage bbsThreadTabPage = this.SelectedBbsThreadTapPage;
				if(bbsThreadTabPage != null) {
					BbsThread bbsThread = bbsThreadTabPage.BbsThread;
					if(bbsThread != null) {
						bbsThread.UpdateThread();//\eXV
					}
				}
			} else if(e.Button == this.closeTabButton) {
				//^uN[Y
				TabPage tabPage = this.bbsThreadTabView.SelectedTab;
				if(this.BbsThreadTabView.TabPages.Count > 1) {
					this.BbsThreadTabView.TabPages.Remove(tabPage);
				}
			}
		}
		
		/// <summary>
		/// ^C}
		/// IɂȂꍇPbɌĂяoA
		/// Oʂ̍XVA]󋵉ʂ̍XVAT[ogXgʂ̍XVs
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void timer_Tick(object sender, System.EventArgs e) {
			TabPage page = this.TabView.SelectedTab;
			if(page == this.logTab)
				this.UpdateSystemLogTextBox(model.Log.GetLog());
			else if(page == this.serventTab)
				this.UpdateServentList();
			else
				this.timer.Stop();

			//test
			//Console.WriteLine(DateTime.Now);
			//end-test
		}

		/// <summary>
		/// NbNꂽꍇAhttp://www.zigumo.org/ \B
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void zigumoOrgLinkLabel_Click(object sender, System.EventArgs e) {
			Process.Start("iexplore.exe", this.zigumoOrgLinkLabel.Text);
		}
		
		/// <summary>
		/// I
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ZigumoForm_Closed(object sender, System.EventArgs e) {
			commandController.ShutdownWorkers();
			connectionManager.Close();

			SaveCategoryTreeView();

			model.Log.Write("zigumo ShutDown\r\n");
			model.Log.Close();

			//EChETCYۑ
			model.Width = this.Width;
			model.Height = this.Height;
			model.SplitterWidth = this.splitter1.SplitPosition;
			model.SplitterHeight = this.splitter2.SplitPosition;

			model.SaveConfiguration();
		}

		/// <summary>
		/// eXgpGg[|CgAhX̐ݒ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void connectionSetupMenu_Click(object sender, System.EventArgs e) {
			ConnectionSetupDialog dlg = new ConnectionSetupDialog();
			dlg.EntryPointAddress = model.EntryPointAddress.ToString();
			if(dlg.ShowDialog() == DialogResult.OK) {
				model.EntryPointAddress = dlg.EntryPointAddress;
			}
		}
		
		/// <summary>
		/// eXgpڑs
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void connectZigumonetMenu_Click(object sender, System.EventArgs e) {
			if(model.EntryPointAddress.IndexOf("http://") == 0) {
				commandController.PutCommand(new ConnectEntryPointCommand());//ڑR}hs
			} else {
				MessageBox.Show("Gg[|Cgݒ肳Ă܂B");
			}
		}
		
		/// <summary>
		/// eXgpnhVFCN
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void handShakeMenu_Click(object sender, System.EventArgs e) {
			ConnectionSetupDialog dlg = new ConnectionSetupDialog();
			if(dlg.ShowDialog() == DialogResult.OK) {
				int idx = dlg.EntryPointAddress.IndexOf(":");
				string ip = dlg.EntryPointAddress.Substring(0, idx);
				string port = dlg.EntryPointAddress.Substring(idx + 1);
				Servent servent = new Servent(IPAddress.Parse(ip), Int32.Parse(port));
				commandController.PutCommand(new SendHandShakeCommand(servent));
			}
		}

		/// <summary>
		/// eXgpeXĝ߂̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void pingMenu_Click(object sender, System.EventArgs e) {
		
			PingMessage ping = new PingMessage();
			ping.CreateHeader();

			connectionManager.SendMessage(ping);
		}

		/// <summary>
		/// eXgpeXĝ߂̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void queryChatMenu_Click(object sender, System.EventArgs e) {
			ChoiceCategoryTreeDialog dlg = new ChoiceCategoryTreeDialog();
			
			if(dlg.ShowDialog() == DialogResult.OK) {
				BbsCategory bbsCategory = dlg.SelectedCategory;
				if(bbsCategory != null) {
					byte[] categoryByte = Encoding.ASCII.GetBytes(bbsCategory.Bbs2chBaseUrl);
					QueryChatMessage queryChat = new QueryChatMessage(Zigumo.MessageObject.Message.headerSize +
						QueryChatMessage.basePayloadSize + categoryByte.Length);
					queryChat.CreateHeader();
					queryChat.PayloadSize = QueryChatMessage.basePayloadSize + categoryByte.Length;
					queryChat.Category = categoryByte;

					//test
					Console.WriteLine("queryChatˁII" + bbsCategory.CategoryID);

					connectionManager.SendMessage(queryChat);
				}
			}//end if	
		}

		/// <summary>
		/// eXgpeXĝ߂̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void testMenu_Click(object sender, System.EventArgs e) {
			//NG[`bgeXg
			string category = "http://pc3.2ch.net/tech/";
			byte[] categoryByte = Encoding.ASCII.GetBytes(category);
			QueryChatMessage queryChat = new QueryChatMessage(Zigumo.MessageObject.Message.headerSize +
				QueryChatMessage.basePayloadSize + categoryByte.Length);
			queryChat.CreateHeader();
			queryChat.PayloadSize = QueryChatMessage.basePayloadSize + categoryByte.Length;
			queryChat.Category = categoryByte;

			byte[] categoryByte2 = queryChat.Category;
			string category2 = Encoding.ASCII.GetString(categoryByte2);


			//NG[`bgqbgeXg
			int port = 6340;
			IPAddress ip = IPAddress.Parse("192.168.0.14");
			Guid serventID = Guid.NewGuid();
			int number = 3;
			int maxNumber = 24;
			string name = "qقzigumo{c";
			byte[] chatName = Encoding.Unicode.GetBytes(name);
			
			QueryChatHitMessage queryChatHit = new QueryChatHitMessage(Zigumo.MessageObject.Message.headerSize +
				QueryChatHitMessage.basePayloadSize + chatName.Length);
			queryChatHit.CreateHeader();
			queryChatHit.PayloadSize = QueryChatHitMessage.basePayloadSize + chatName.Length;
			queryChatHit.Port = port;
			queryChatHit.Address = ip;
			queryChatHit.ServentIDToGuid = serventID;
			queryChatHit.ChatNumber = number;
			queryChatHit.ChatMaxNumber = maxNumber;
			queryChatHit.ChatName = chatName;
			
			int port2 = queryChatHit.Port;
			string ip2 = queryChatHit.Address.ToString();
			int number2 = queryChatHit.ChatNumber;
			int maxNumber2 = queryChatHit.ChatMaxNumber;
			Guid serventID2 = queryChatHit.ServentIDToGuid;
			byte[] chatName2 = queryChatHit.ChatName;
			string name2 = Encoding.Unicode.GetString(chatName2);
			
			int a = 0;
			a++;
/*
			Guid threadID = Guid.NewGuid();
			int startRes = 10;
			int endRes = 20;
			string category = "http://pc3.2ch.net/tech/";
			byte[] categoryByte = Encoding.ASCII.GetBytes(category);
			QueryMessage query = new QueryMessage(Zigumo.MessageObject.Message.headerSize +
				QueryMessage.basePayloadSize + categoryByte.Length);
			query.CreateHeader();
			query.PayloadSize = QueryMessage.basePayloadSize + categoryByte.Length;
			query.ThreadIDToGuid = threadID;
			query.StartResNo = startRes;
			query.EndResNo = endRes;
			query.Category = categoryByte;

			Guid threadID2 = query.ThreadIDToGuid;
			int startRes2 = query.StartResNo;
			int endRes2 = query.EndResNo;
			byte[] categoryByte2 = query.Category;
			string category2 = Encoding.ASCII.GetString(categoryByte2);
			
			int port = 6340;
			IPAddress ip = IPAddress.Parse("192.168.0.14");
			Guid serventID = Guid.NewGuid();
			byte[] hitData = {0,1,2,3,4,5,6,7,8,9,8,7,6,5,4,3,2,1,0};
			
			QueryHitMessage queryHit = new QueryHitMessage(Zigumo.MessageObject.Message.headerSize +
				QueryHitMessage.basePayloadSize + hitData.Length);
			queryHit.CreateHeader();
			queryHit.PayloadSize = QueryHitMessage.basePayloadSize + hitData.Length;
			queryHit.Port = port;
			queryHit.Address = ip;
			queryHit.ServentIDToGuid = serventID;
			queryHit.HitData = hitData;
			
			int port2 = queryHit.Port;
			string ip2 = queryHit.Address.ToString();
			Guid serventID2 = queryHit.ServentIDToGuid;
			byte[] hitData2 = queryHit.HitData;

			PushMessage push = new PushMessage(Zigumo.MessageObject.Message.headerSize +
				PushMessage.basePayloadSize + categoryByte.Length);
			push.CreateHeader();
			push.PayloadSize = PushMessage.basePayloadSize + categoryByte.Length;
			push.Port = port;
			push.Address = ip;
			push.ServentIDToGuid = serventID;
			push.ThreadIDToGuid = threadID;
			push.StartResNo = startRes;
			push.EndResNo = endRes;
			push.Category = categoryByte;

			int port3 = push.Port;
			string ip3 = push.Address.ToString();
			Guid serventID3 = push.ServentIDToGuid;
			Guid threadID3 = push.ThreadIDToGuid;
			int startRes3 = push.StartResNo;
			int endRes3 = push.EndResNo;
			byte[] categoryByte3 = push.Category;
			string category3 = Encoding.ASCII.GetString(categoryByte3);;
*/
		}

		/// <summary>
		/// eXgpeXĝ߂̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void queryMenu_Click(object sender, System.EventArgs e) {
			Guid threadID = Guid.NewGuid();
			int startRes = 10;
			int endRes = 20;
			string category = "http://pc3.2ch.net/tech/";
			byte[] categoryByte = Encoding.ASCII.GetBytes(category);
			QueryMessage query = new QueryMessage(Zigumo.MessageObject.Message.headerSize +
				QueryMessage.basePayloadSize + categoryByte.Length);
			query.CreateHeader();
			query.PayloadSize = QueryMessage.basePayloadSize + categoryByte.Length;
			query.ThreadIDToGuid = threadID;
			query.StartResNo = startRes;
			query.EndResNo = endRes;
			query.Category = categoryByte;
			
			connectionManager.SendMessage(query);
		}

		/// <summary>
		/// eXgpeXĝ߂̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void forceTestMenu_Click(object sender, System.EventArgs e) {
			//׎
			commandController.PutCommand(new TestCommand());
		
		}

		/// <summary>
		/// vt@Xݒ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void preferenceMenuItem_Click(object sender, System.EventArgs e) {
			PreferenceDialog dlg = new PreferenceDialog();
			if (dlg.ShowDialog() == DialogResult.OK) {
			}
		}

		/// <summary>
		/// `bgT[oݒ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void chatMenuItem_Click(object sender, System.EventArgs e) {
			ChatConfigDialog dlg = new ChatConfigDialog();
			dlg.ChatName = model.ChatName;
			dlg.ChatMaxNumber = model.ChatMaxNumber;
			dlg.ChatServer = model.ChatServer;
			dlg.ChatCategory = model.ChatCategory;

			if(dlg.ShowDialog() == DialogResult.OK) {
				model.ChatName = dlg.ChatName;
				model.ChatMaxNumber = dlg.ChatMaxNumber;
				model.ChatServer = dlg.ChatServer;
				model.ChatCategory = dlg.ChatCategory;
			}
		}

		/// <summary>
		/// zigumoXbh^uXgJ\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void openZigumoTabMenu_Click(object sender, System.EventArgs e) {
			BbsCategoryTabPage tabPage = new BbsCategoryTabPage(this, BbsType.Zigumo);
			bbsCategoryTabView.TabPages.Add(tabPage);
			bbsCategoryTabView.SelectedTab = tabPage;
			TreeNode node = this.bbsCategoryTreeView.SelectedNode;
			//JeS擾
			BbsCategory category = (BbsCategory)node.Tag;
			//XbhXgXV
			if(category != null) {
				//IĂ^uɉď؂ւ
				if(this.TabView.SelectedTab == this.bbsTab) {
					//BBS^uI𒆂̓XbhXg̍XVs
					category.TabPage = this.SelectedBbsCategoryTabPage;//\̃^uݒ
					category.UpdateCategory();//\eXV
				}
			}
		}

		/// <summary>
		/// 2chXbh^uXgJ\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void open2chTabMenu_Click(object sender, System.EventArgs e) {
			BbsCategoryTabPage tabPage = new BbsCategoryTabPage(this, BbsType.Bbs2ch);
			bbsCategoryTabView.TabPages.Add(tabPage);
			bbsCategoryTabView.SelectedTab = tabPage;
			TreeNode node = this.bbsCategoryTreeView.SelectedNode;
			//JeS擾
			BbsCategory category = (BbsCategory)node.Tag;
			//XbhXgXV
			if(category != null) {
				//IĂ^uɉď؂ւ
				if(this.TabView.SelectedTab == this.bbsTab) {
					//BBS^uI𒆂̓XbhXg̍XVs
					category.TabPage = this.SelectedBbsCategoryTabPage;//\̃^uݒ
					category.UpdateCategory();//\eXV
				}
			}
		}

		/// <summary>
		/// JeSc[zigumoT[o̐ݒs_CAOJ\bh
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void zigumoServerMenu_Click(object sender, System.EventArgs e) {
			TreeNode node = this.bbsCategoryTreeView.SelectedNode;
			//JeS擾
			BbsCategory category = (BbsCategory)node.Tag;

			CategoryPropertyDialog dlg = new CategoryPropertyDialog();

			string property = "";
			//JeSID̎擾
			property += "JeSIDF" + category.CategoryID + "\r\n";
			//JeS̎擾
			property += "JeSF" + category.CategoryGroup + "/" + category.Name + "\r\n";
			//2chURL̕\
			property += "2chF" + category.Bbs2chUrl + "\r\n";
			//zigumoURL̕\
			ArrayList list = category.ZigumoBaseUrl;
			if(list != null) {
				foreach(string url in list) {
					property += "zigumoF" + url + "\r\n";
				}
			}

			dlg.CategoryGroup = property;
			if(dlg.ShowDialog() == DialogResult.OK) {
				
			}

		}



	}//end class
}
